<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Download extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for download section
     return array(
                  'allowed_section'               => WM3_cSECTION_DOWNLOADS,
                  'allow_category_description'    => true,
                  'allow_subcategory_description' => true,
                  'category_form'                 => 'admin_download_category_form.inc',
                  'search_form'                   => 'admin_download_search_form.inc',
                  'subcategory_form'              => 'admin_download_subcategory_form.inc',
                  'table_categories'              => '_downloads_categories',
                  'table_subcategories'           => '_downloads_subcategories',
                  'table_subcategories_count'     => '_downloads_subcategories',
                  'table_items_count'             => '_downloads',
                  'action_save_category'          => WM3_cACTION_SAVE_DOWNLOAD_CATEGORY,
                  'action_update_category'        => WM3_cACTION_UPDATE_DOWNLOAD_CATEGORY,
                  'action_show_subcategory'       => WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY,
                  'action_add_subcategory'        => WM3_cACTION_ADD_DOWNLOAD_SUBCATEGORY,
                  'action_disable_category'       => WM3_cACTION_DISABLE_DOWNLOAD_CATEGORY,
                  'action_enable_category'        => WM3_cACTION_ENABLE_DOWNLOAD_CATEGORY,
                  'action_edit_category'          => WM3_cACTION_EDIT_DOWNLOAD_CATEGORY,
                  'action_delete_category'        => WM3_cACTION_DELETE_DOWNLOAD_CATEGORY,
                  'action_update_subcategory'     => WM3_cACTION_UPDATE_DOWNLOAD_SUBCATEGORY,
                  'action_save_subcategory'       => WM3_cACTION_SAVE_DOWNLOAD_SUBCATEGORY,
                  'action_show_items'             => WM3_cACTION_SHOW_DOWNLOAD,
                  'action_add_item'               => WM3_cACTION_ADD_DOWNLOAD,
                  'action_disable_subcategory'    => WM3_cACTION_DISABLE_DOWNLOAD_SUBCATEGORY,
                  'action_enable_subcategory'     => WM3_cACTION_ENABLE_DOWNLOAD_SUBCATEGORY,
                  'action_edit_subcategory'       => WM3_cACTION_EDIT_DOWNLOAD_SUBCATEGORY,
                  'action_delete_subcategory'     => WM3_cACTION_DELETE_DOWNLOAD_SUBCATEGORY,
                  'action_search'                 => WM3_cACTION_SHOW_DOWNLOAD,
                  'label_category_list_title'     => 1678,
                  'label_subcategory_add'         => 1663,
                  'label_subcategories_count'     => 1051,
                  'label_items_count'             => 1108,
                  'label_item_add'                => 661,				  
                  'extra_button_action'           => WM3_cACTION_SHOW_DOWNLOAD_TOP_RATING,
				  'extra_button_icon'             => 'action_up.png',
				  'extra_button_label'            => 1216);
    }

   public static function getDownloadFieldsArray()
    { // TODO update_ts ???
     return array('downloadID','subcategoryID','name','source','download_from_local','download','download_from_remote','hits','download_from_external','render_mode','description','enabled','languageID','ts');
    }

   public static function getDownloadPictureFieldsArray()
    { // TODO update_ts ???
     //return array('pictureID','downloadID','picture','thumbnail','description','enabled','languageID','ts','categoryID','subcategoryID');
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // Download page content
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_DOWNLOAD:
        {
         return wm3Download::getDownloadList($w3,0,false);
         break;
        }
       case WM3_cACTION_SHOW_SINGLE_DOWNLOAD:
        {
         return wm3Download::renderDownload($w3);
         break;
        }
       case WM3_cACTION_GET_FILE_DOWNLOAD:
        {
		 wm3Download::hitDownload($w3);
         return wm3Download::getDownloadFile($w3);
         break;
        }
       case WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY:
        {
         return wm3Download::getDownloadSubcategoryList($w3,0,false);
         break;
        }
       case WM3_cACTION_SHOW_DOWNLOAD_TOP_RATING:
        {
         /*return wm3Download::renderDownloadTopRating($w3,"ORDER BY votes_average DESC",1219,true, false,false)."<br><br>".
		        wm3Download::renderDownloadTopRating($w3,"ORDER BY hits DESC"         ,1220,false,true, false)."<br><br>".
				wm3Download::renderDownloadTopRating($w3,"ORDER BY votes_counts DESC" ,1221,false,false,true);*/
		 return wm3Download::renderDownloadTopRating($w3,"ORDER BY hits DESC"         ,1220,false,true, false);
         break;
        }
       default:
        {
         return wm3Download::getDownloadCategoryList($w3,0,false);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_DOWNLOAD_CATEGORY:
        {
         return wm3Download::addDownloadCategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_DOWNLOAD_CATEGORY:
        {
         $error = wm3Download::checkDownloadCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Download::saveDownloadCategory($w3);
           // $msg= message saved... //TODO
           return wm3Download::getDownloadCategoryList($w3,$lastID);
          }
         else return wm3Download::addDownloadCategory($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_DOWNLOAD_CATEGORY:
        {
         return wm3Download::editDownloadCategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_DOWNLOAD_CATEGORY:
        {
         $error = wm3Download::checkDownloadCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Download::updateDownloadCategory($w3);
           // $msg= message udated... //TODO
           return wm3Download::getDownloadCategoryList($w3,$lastID);
          }
         else return wm3Download::editDownloadCategory($w3,$error);
         break;
        }
       case WM3_cACTION_DISABLE_DOWNLOAD_CATEGORY:
        {
         wm3Download::disableDownloadCategory($w3->getVariable('categoryID','get'));
         return wm3Download::getDownloadCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_DOWNLOAD_CATEGORY:
        {
         wm3Download::enableDownloadCategory($w3->getVariable('categoryID','get'));
         return wm3Download::getDownloadCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_DOWNLOAD_CATEGORY:
        {
         wm3Download::deleteDownloadCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Download::getDownloadCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_DOWNLOAD_SUBCATEGORY:
        {
         return wm3Download::addDownloadSubcategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_DOWNLOAD_SUBCATEGORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories    WRITE");
         $error = wm3Download::checkDownloadSubcategoryError($w3);
         if(!$error) {
                      $lastID = wm3Download::saveDownloadSubcategory($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Download::getDownloadSubcategoryList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Download::addDownloadSubcategory($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_DOWNLOAD_SUBCATEGORY:
        {
         wm3Download::disableDownloadSubcategory($w3->getVariable('subcategoryID','get'));
         return wm3Download::getDownloadSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_DOWNLOAD_SUBCATEGORY:
        {
         wm3Download::enableDownloadSubcategory($w3->getVariable('subcategoryID','get'));
         return wm3Download::getDownloadSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_DOWNLOAD_SUBCATEGORY:
        {
         wm3Download::deleteDownloadSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Download::getDownloadSubcategoryList($w3);
         break;
        }
       case WM3_cACTION_EDIT_DOWNLOAD_SUBCATEGORY:
        {
         return wm3Download::editDownloadSubcategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_DOWNLOAD_SUBCATEGORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories    WRITE");
         $error = wm3Download::checkDownloadSubcategoryError($w3);
         if(!$error) {
                      $lastID = wm3Download::updateDownloadSubcategory($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Download::getDownloadSubcategoryList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Download::editDownloadSubcategory($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_ADD_DOWNLOAD:
        {
         return wm3Download::addDownload($w3);
         break;
        }
       case WM3_cACTION_SAVE_DOWNLOAD:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_downloads               WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories    WRITE");
         $error = wm3Download::checkDownloadError($w3);
         if(!$error) {
                      $lastID = wm3Download::saveDownload($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Download::getDownloadList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Download::addDownload($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_EDIT_DOWNLOAD:
        {
         return wm3Download::editDownload($w3);
         break;
        }
       case WM3_cACTION_UPDATE_DOWNLOAD:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_downloads               WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories    WRITE");
         $error = wm3Download::checkDownloadError($w3);
         if(!$error) {
                      $lastID = wm3Download::updateDownload($w3);
           			  wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Download::getDownloadList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Download::editDownload($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_DOWNLOAD:
        {
         wm3Download::disableDownload($w3->getVariable('downloadID','get'));
         return wm3Download::getDownloadList($w3,$w3->getVariable('downloadID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_DOWNLOAD:
        {
         wm3Download::enableDownload($w3->getVariable('downloadID','get'));
         return wm3Download::getDownloadList($w3,$w3->getVariable('downloadID','get'));
         break;
        }
       case WM3_cACTION_DELETE_DOWNLOAD:
        {
         wm3Download::deleteDownload($w3->getVariable('downloadID','get'));
         return wm3Download::getDownloadList($w3);
         break;
        }
       case WM3_cACTION_DUPLICATE_DOWNLOAD:
        {
         $lastID = wm3Download::duplicateDownload($w3);
         return wm3Download::getDownloadList($w3,$lastID);
         break;
        }
       case WM3_cACTION_SHOW_DOWNLOAD:
        {
         return wm3Download::getDownloadList($w3);
         break;
        }
       case WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY:
        {
         return wm3Download::getDownloadSubcategoryList($w3);
         break;
        }
       default:
        {
         return wm3Download::getDownloadCategoryList($w3);
        }
      }     
    }

   public static function getDownloadCategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin,false,false,'',false,false,false,false,false,'',true);
    }

   public static function checkDownloadCategoryError($w3)
    {
     return $w3->getSectionObj()->checkCategoryError($w3);
    }

   public static function addDownloadCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editDownloadCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function saveDownloadCategory($w3)
    {
     return $w3->getSectionObj()->saveCategory($w3);
    }

   public static function updateDownloadCategory($w3)
    {
     return $w3->getSectionObj()->updateCategory($w3);
    }

   public static function disableDownloadCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableDownloadCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteDownloadCategory($w3,$categoryID)
    {
     $w3->getSectionObj()->deleteCategory($categoryID);
    }

   public static function selectDownloadCategory($w3,$name,$categoryID,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$name,$categoryID,$all,$admin);
    }

   public static function getDownloadCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($categoryID);
    }

   public static function getDownloadSubcategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getSubcategoryList($w3,$currentID,$admin,false,false,'',false,false,false,false,true);
    }

   public static function checkDownloadSubcategoryError($w3)
    {
     return $w3->getSectionObj()->checkSubcategoryError($w3);
    }

   public static function addDownloadSubcategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addSubcategory($w3,$error);
    }

   public static function editDownloadSubcategory($w3,$error = 0) 
    {
     return $w3->getSectionObj()->editSubcategory($w3,$error);
    }

   public static function saveDownloadSubcategory($w3) 
    {
     return $w3->getSectionObj()->saveSubcategory($w3);
    }

   public static function updateDownloadSubcategory($w3)
    {
     return $w3->getSectionObj()->updateSubcategory($w3);
    }

   public static function disableDownloadSubcategory($subcategoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories SET enabled = '".WM3_cDISABLED."' WHERE subcategoryID = '$subcategoryID'");
    }

   public static function enableDownloadSubcategory($subcategoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories SET enabled = '".WM3_cENABLED."' WHERE subcategoryID = '$subcategoryID'");
    }
   
   public static function deleteDownloadSubcategory($w3,$subcategoryID)
    {
     $w3->getSectionObj()->deleteSubcategory($subcategoryID);
    }

   public static function getDownloadSubcategoryName($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getSubcategoryName($subcategoryID);
    }

   public static function selectDownloadSubcategory($w3,$name,$subcategoryID,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectSubcategory($w3,$name,$subcategoryID,$all,$admin);
   	}

   public static function getDownloadCategoryID($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getCategoryID($subcategoryID);
    }

   public static function getDownloadList($w3,$currentID = 0,$admin = true)
    {
     // Get downloads list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DOWNLOADS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID','both');
     $subcategoryID = $w3->getVariable('subcategoryID','both');
     if($subcategoryID && !$categoryID) // When make a search take only subcategoryID (but need also categoryID)
      $categoryID = wm3Download::getDownloadCategoryID($w3,$subcategoryID);
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID = '$subcategoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.description LIKE '%$filter%'";
     	         }
     else        { if(!$subcategoryID) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
                 $width_name       = 50;
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_DOWNLOAD;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 6; $buttons = 4;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DOWNLOAD."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $width_name       = 100;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".WM3_cLANGUAGE_ALL."') ";
     	         if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DOWNLOADS;
     $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_downloads.description DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'downloadID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_download_search_form.inc");
     if($admin) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(1678)."</a>");
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(1678)."</a>");
     if($subcategoryID)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link."&categoryID=$categoryID&action=".WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY."\">".wm3Download::getDownloadCategoryName($w3,$categoryID)."</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$page_link."&categoryID=$categoryID&action=".WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY."\">".wm3Download::getDownloadCategoryName($w3,$categoryID)."</a>");
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_DOWNLOAD."\">".wm3Download::getDownloadSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD."\">".wm3Download::getDownloadSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
       if($admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_DOWNLOAD,"action_add.png","","",$w3->getWord(661),0,16,16));
      }
	 if(!$admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_name,50,0),array(194,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&downloadID=$row->downloadID";
	   $description = wm3Util::renderContent($w3,$row->description,$row->render_mode);
       if($allowed) $allowed_link = $base_allowed_link."&downloadID=$row->downloadID";
       if($subcategoryID) {
                           if($admin) array_push($_CONTENTS,"<a href=\"".wm3Download::makeDownloadDirectLink($w3,$row)."\">$row->name</a><br><br><i>$description</i>");
				           else       array_push($_CONTENTS,"<a href=$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD.">$row->name</a> ($row->hits downloads)<br><br><i>$description</i><div align=\"right\">".wm3Util::actionButton("$link$page_link&action=".WM3_cACTION_GET_FILE_DOWNLOAD,"action_down.png","","",$w3->getWord(1087),0,16,16)." </div>");
                          }
       else               {
       	                   // For the search in all categories -> subcategories
						   $_PSEP = $w3->getSkinObj()->getPathSeparator();
                           if($admin) {
							           array_push($_CONTENTS,"<a href=\"".wm3Download::makeDownloadDirectLink($w3,$row)."\">$row->name</a><br><i>$description</i><br>(".$w3->getWord(659)."
                           	                      <a href=\"".$base_link."&categoryID=".$w3->getSectionObj()->getCategoryID($row->subcategoryID)."&action=".WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY."\">".wm3Download::getDownloadCategoryName($w3,$w3->getSectionObj()->getCategoryID($row->subcategoryID))."</a>
                           	                      $_PSEP <a href=\"".$base_link.$search_link."&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_DOWNLOAD."\">".wm3Download::getDownloadSubcategoryName($w3,$row->subcategoryID)."</a>)");
									  }
                           else       {
							           array_push($_CONTENTS,"<a href=$base_link$page_link&categoryID=".$w3->getSectionObj()->getCategoryID($row->subcategoryID)."&subcategoryID=$row->subcategoryID&downloadID=$row->downloadID&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD.">$row->name</a><br>(".$w3->getWord(659)."
                           	                      <a href=\"$base_link$page_link&categoryID=".$w3->getSectionObj()->getCategoryID($row->subcategoryID)."&action=".WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY."\">".wm3Download::getDownloadCategoryName($w3,$w3->getSectionObj()->getCategoryID($row->subcategoryID))."</a>
                           	                      $_PSEP <a href=\"$base_link$search_link$page_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_DOWNLOAD."\">".wm3Download::getDownloadSubcategoryName($w3,$row->subcategoryID)."</a>)");
									  }
                          }
       array_push($_WIDTHS,$width_name);
       if($admin)
        {
		 $file_size = wm3Folder::renderFileSize($w3,@filesize(wm3Download::makeDownloadDirectLink($w3,$row)),$w3->getWord(1075));
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 $info = $lang_flag."<br><a href=\"".wm3Download::makeDownloadDirectLink($w3,$row)."\">$row->download</a> ($row->hits downloads)<br>$file_size";
         array_push($_CONTENTS,$info); array_push($_WIDTHS,50);
         // Buttons
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_DOWNLOAD,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_DOWNLOAD,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_DOWNLOAD,"action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DUPLICATE_DOWNLOAD,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_DOWNLOAD,"action_delete.png",$w3->getWord(179),$w3->getWord(772)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DOWNLOAD,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->downloadID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_DOWNLOAD.$id_link.$search_link);
       else       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkDownloadError($w3)
    {
     // Check form invalid inputs and upload error
     $_FIELD = webmatic3::getPostValueArray(wm3Download::getDownloadFieldsArray());

     if(!$_FIELD['name']) return 7;
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL) // Take file from local hard drive
      {
       $aux = time()."_".rand(1,99999); // Avoid overwritting the files
       // Upload the file and give the name to the files
       if($_FILES['download_from_local']['name']) $download_name = $aux.".".wm3Util::cutExtension($_FILES['download_from_local']['name']);
       else                                       $download_name = "";
       $error = wm3Folder::uploadFile("download_from_local",WM3_cPATH_DOWNLOADS,$download_name,true,wm3Folder::mimeTypeApplicationDocument(),0);
       if($error) return $error;
      }
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_URL) if(!wm3Util::isUrl($_FIELD['download_from_external']) && !wm3Util::isUrlRelative($_FIELD['download_from_external'])) return 8; // External link
	 if(!$w3->getSectionObj()->existsSubcategory($_FIELD['subcategoryID'])) return 9;
     return 0; // Take file from remote folder (or no errors)
    }

   public static function addDownload($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Download::getDownloadFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Download::getDownloadFieldsArray());
     // Fields for paging default value
     $pg = $filter = "";
     
     // Hide/Show correct field and error
     $_EXTRA_STYLE['download_from_local'] = $_EXTRA_STYLE['download_from_remote'] = $_EXTRA_STYLE['download_from_external'] = "style=\"display:none\"";
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL)  $_EXTRA_STYLE['download_from_local']    = "";
	 if($_FIELD['source'] == WM3_cUPLOAD_FROM_REMOTE) $_EXTRA_STYLE['download_from_remote']   = "";
	 if($_FIELD['source'] == WM3_cUPLOAD_FROM_URL)    $_EXTRA_STYLE['download_from_external'] = "";

     switch($error)
      {
       // File upload error
       case 1: // Upload error
        {
         $_STYLE['download_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']           = WM3_cSKIN_ERROR;
         $form_title = "Upload error $error";//$w3->getWord(29);
         break;
        }
       case 2: // File not allowed
        {
         $_STYLE['download_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']           = WM3_cSKIN_ERROR;
         $form_title = "Not allowed $error";//$w3->getWord(29);
         break;
        }
       case 3: // File already exist error
        {
         $_STYLE['download_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']            = WM3_cSKIN_ERROR;
         $form_title = "File already exists (check overwrite box) $error";//$w3->getWord(29);
         break;
        }
       case 5: // File too big
        {
         $_STYLE['download_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']           = WM3_cSKIN_ERROR;
         $form_title = "Too big $error";//$w3->getWord(29);
         break;
        }
       case 6: // Empty file given (no upload performed)
        {
         $_STYLE['download_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']           = WM3_cSKIN_ERROR;
         $form_title = "Empty file name $error";//$w3->getWord(29);
         break;
        }
       // Other errors
       case 7: // Empty name
        {
         $_STYLE['name']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error empty name$error";//$w3->getWord(29);
         break;
        }
       case 8: // Invalid external link
        {
         $_STYLE['download_from_external'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']              = WM3_cSKIN_ERROR;
         $form_title = "Error invalid url $error";//$w3->getWord(29);
         break;
        }
       case 9: // Subcategory do not exists
        {
         $_STYLE['subcategoryID'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']     = WM3_cSKIN_ERROR;
         $form_title = "Error $error invalid subcategory";//$w3->getWord(29);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['categoryID']    = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['subcategoryID'] = $w3->getVariable('subcategoryID','get'); // Take subcategoryID from get
         $_FIELD['enabled']       = WM3_cENABLED;
       
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1063);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_DOWNLOAD;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_download_form.inc");
     return $content;
    }

   public static function editDownload($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_downloads
                               WHERE downloadID = '".$w3->getVariable('downloadID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Download::getDownloadFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Download::getDownloadFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Download::getDownloadFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');

     // Hide/Show correct field and error
     $_EXTRA_STYLE['download_from_local'] = $_EXTRA_STYLE['download_from_remote'] = $_EXTRA_STYLE['download_from_external'] = "style=\"display:none\"";
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL)  $_EXTRA_STYLE['download_from_local']    = "";
	 if($_FIELD['source'] == WM3_cUPLOAD_FROM_REMOTE) $_EXTRA_STYLE['download_from_remote']   = "";
	 if($_FIELD['source'] == WM3_cUPLOAD_FROM_URL)    $_EXTRA_STYLE['download_from_external'] = "";

     switch($error)
      {
       // File upload error
       case 1: // Upload error
        {
         $_STYLE['download_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']      = WM3_cSKIN_ERROR;
         $form_title = "Upload error $error";//$w3->getWord(29);
         break;
        }
       case 2: // File not allowed
        {
         $_STYLE['download_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']      = WM3_cSKIN_ERROR;
         $form_title = "Not allowed $error";//$w3->getWord(29);
         break;
        }
       case 3: // File already exist error
        {
         $_STYLE['download_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']      = WM3_cSKIN_ERROR;
         $form_title = "File already exixte (check overwrite box) $error";//$w3->getWord(29);
         break;
        }
       case 5: // File too big
        {
         $_STYLE['download_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']      = WM3_cSKIN_ERROR;
         $form_title = "Too big $error";//$w3->getWord(29);
         break;
        }
       case 6: // Empty file given (no upload performed)
        {
         $_STYLE['download_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']      = WM3_cSKIN_ERROR;
         $form_title = "Empty file name $error";//$w3->getWord(29);
         break;
        }
       // Other errors
       case 7: // Empty name
        {
         $_STYLE['name']           = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error empty name$error";//$w3->getWord(29);
         break;
        }
       case 8: // Invalid external link
        {
         $_STYLE['download_from_external'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']         = WM3_cSKIN_ERROR;
         $form_title = "Error invalid url $error";//$w3->getWord(29);
         break;
        }
       case 9: // Subcategory do not exists
        {
         $_STYLE['subcategoryID']  = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error invalid subcategory";//$w3->getWord(29);
         break;
        }
       default:
        {
         $_FIELD['download_from_local'] = $_FIELD['download_from_remote'] = $_FIELD['download_from_external'] = "";
         if($_FIELD['source'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['download_from_remote']   = $_FIELD['download'];
	     if($_FIELD['source'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['download_from_external'] = $_FIELD['download'];
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1077);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_DOWNLOAD;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_download_form.inc");
     return $content;
    }

   public static function saveDownload($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Download::getDownloadFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['download'] = $_FILES['download_from_local']['name'];
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['download'] = $_FIELD['download_from_remote'];
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['download'] = $_FIELD['download_from_external'];
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['source'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "source" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_downloads',$_FIELD,array('download_from_local','download_from_remote','download_from_external'));
     return wm3Sql::getLastInsertID();
    }

   public static function updateDownload($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Download::getDownloadFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['download'] = $_FILES['download_from_local']['name'];
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['download'] = $_FIELD['download_from_remote'];
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['download'] = $_FIELD['download_from_external'];
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['source'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "source" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     // TODO Attenzionare campo categoryID (da togliere ???)
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
                       SET   subcategoryID = '".$_FIELD['subcategoryID']."',
                             name          = '".$_FIELD['name']."',
                             description   = '".$_FIELD['description']."',
							 render_mode   = '".$_FIELD['render_mode']."',
                             download      = '".$_FIELD['download']."',
                             source        = '".$_FIELD['source']."',
                             enabled       = '".$_FIELD['enabled']."',
                             languageID    = '".$_FIELD['languageID']."'
                       WHERE downloadID    = '".$_FIELD['downloadID']."'");
     return $_FIELD['downloadID'];
    }

   public static function duplicateDownload($w3)
    {
     // Take fields from database and duplicate data creating a new row	 
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_downloads               WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories    WRITE");
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_downloads
                             WHERE downloadID = '".$w3->getVariable('downloadID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Download::getDownloadFieldsArray(),$row,WM3_cQUOTE_DB);
       $_FIELD['name']    = $w3->getWord(1417).$_FIELD['name'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['ts']      = time();
       wm3Sql::saveAllTableFields('_downloads',$_FIELD);
	   wm3Sql::sqlQuery("UNLOCK TABLES");
       return wm3Sql::getLastInsertID();
      }
	 wm3Sql::sqlQuery("UNLOCK TABLES");
    }

   public static function disableDownload($downloadID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads SET enabled = '".WM3_cDISABLED."' WHERE downloadID = '$downloadID'");
    }

   public static function enableDownload($downloadID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads SET enabled = '".WM3_cENABLED."' WHERE downloadID = '$downloadID'");
    }
   
   public static function deleteDownload($downloadID)
    {
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_downloads WHERE downloadID = '$downloadID'");
    }

   /*public static function selectDownloads($name,$messageID)
    {
     // Make download select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages");
     $str = "<select name=\"$name\">";
     while($row = mysql_fetch_object($rs))
      {
       if($row->messageID == $messageID) $str .= wm3Util::inputOption($row->arg_name,$row->arg_blockID,"selected");
       else                              $str .= wm3Util::inputOption($row->arg_name,$row->arg_blockID);
      }
     $str .= "</select>";
     return $str;
    }*/

   public static function getDownloadName($downloadID)
    {
     $rs = wm3Sql::sqlQuery("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_downloads
                             WHERE downloadID = '$downloadID'");
     $row = mysql_fetch_object($rs);
     return $row->name;
    }

   public static function selectDownloadSource($w3,$name,$source,$js = "")
    {
     // Make download source select
     return wm3Util::selectArray($name,
                        array($w3->getWord(1061)."from local drive","from remote folder",$w3->getWord(1062)),
                        array(WM3_cUPLOAD_FROM_LOCAL,WM3_cUPLOAD_FROM_REMOTE,WM3_cUPLOAD_FROM_URL),
                        $source,
                        $js);
    }

   public static function renderDownload($w3,$admin = false)
    {
     // Show a download item (home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DOWNLOADS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID','both');
	 $subcategoryID = $w3->getVariable('subcategoryID','both');
     $downloadID    = $w3->getVariable('downloadID','both');
	 if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID = '$subcategoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) $search_link = "&filter=$filter"; else $search_link = "";
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $pageID = $w3->getVariable('pageID','both');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DOWNLOAD."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".WM3_cLANGUAGE_ALL."') ";
     $columns = 2; $buttons = 0; 
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DOWNLOADS;
	 $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads
			   WHERE  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query."ORDER BY ".WM3_cCONFIG_DB_PREFIX."_downloads.name DESC"); // Do the query without "limit"
	 $rs_aux = $rs;
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query." AND ".WM3_cCONFIG_DB_PREFIX."_downloads.downloadID = '$downloadID'");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_download_search_form.inc");
     if($admin) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(1678)."</a>");
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(1678)."</a>");	 
     if($categoryID)
      {
       $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY."\">".wm3Download::getDownloadCategoryName($w3,$categoryID)."</a>");
       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD."\">".wm3Download::getDownloadSubcategoryName($w3,$subcategoryID)."</a>");
	   array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&downloadID=$downloadID&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD."\">".wm3Download::getDownloadName($downloadID)."</a>");
	   array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $row = mysql_fetch_object($rs);
     $link = $base_link.$id_link.$search_link.$extra_link;
     if($allowed)
	  {
	   $allowed_link = $base_allowed_link."&downloadID=$row->downloadID";
	   $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DOWNLOAD,"action_edit.png",$w3->getWord(178));
      }
     else $button = "";
     $name        = "$button<b>$row->name</b> ($row->hits download from ".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage()).")<br><br>";
	 $description = "<i>".wm3Util::renderContent($w3,$row->description,$row->render_mode)."</i>";
	 $byte        = @filesize(wm3Download::makeDownloadDirectLink($w3,$row));
	 $info        = wm3Download::makeDownloadInfo($w3,$byte);
	 $button      = "<div align=\"right\">".wm3Util::actionButton("$link$page_link&downloadID=$row->downloadID&action=".WM3_cACTION_GET_FILE_DOWNLOAD,"action_down.png","","",$w3->getWord(1087),0,16,16)." </div>";

     $str .= wm3Section::makeItemList($w3,0,array(100),array($name),false,array($columns));
	 $str .= wm3Section::makeItemList($w3,0,array(100),array($description),false,array($columns));
	 $str .= wm3Section::makeItemList($w3,0,array(100),array($info),false,array($columns));
     if($byte !== false)
	  {
	   $_56k  = wm3Download::makeDownloadTime($w3,$byte,7000);
	   $_64k  = wm3Download::makeDownloadTime($w3,$byte,8000);
	   $_640k = wm3Download::makeDownloadTime($w3,$byte,80000);
	   $_7m   = wm3Download::makeDownloadTime($w3,$byte,875000);
	   $_20m  = wm3Download::makeDownloadTime($w3,$byte,2500000);
	   $str .= wm3Section::makeItemList($w3,1,array(10,90),array("Modem 56K",$_56k) ,false);
	   $str .= wm3Section::makeItemList($w3,0,array(10,90),array("ISDN 64K" ,$_64k) ,false);
 	   $str .= wm3Section::makeItemList($w3,1,array(10,90),array("ADSL 640K",$_640k),false);
 	   $str .= wm3Section::makeItemList($w3,0,array(10,90),array("ADSL 7M"  ,$_7m)  ,false);
	   $str .= wm3Section::makeItemList($w3,1,array(10,90),array("ADSL 20M" ,$_20m) ,false);
     }
	 $str .= wm3Section::makeItemList($w3,0,array(100),array($button),false,array($columns));

     // Create list bottom
     if($total_items > 1) $bottom_content = wm3Util::makePagesNavigator(0,0,0,$base_link.$id_link.$search_link.$extra_link.$page_link."&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD,$rs_aux,"downloadID",$row->downloadID);
	 else $bottom_content = "";
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function getDownloadFile($w3,$admin = false)
    {
     // Download file (home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DOWNLOADS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID','both');
	 $subcategoryID = $w3->getVariable('subcategoryID','both');
     $downloadID    = $w3->getVariable('downloadID','both');
	 if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID = '$subcategoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) $search_link = "&filter=$filter"; else $search_link = "";
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $pageID = $w3->getVariable('pageID','both');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_FAQ."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".WM3_cLANGUAGE_ALL."') ";
     $columns = 1; $buttons = 0; 
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DOWNLOADS;
	 $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads
			   WHERE  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query."ORDER BY ".WM3_cCONFIG_DB_PREFIX."_downloads.name DESC"); // Do the query without "limit"
	 $rs_aux = $rs;
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query." AND ".WM3_cCONFIG_DB_PREFIX."_downloads.downloadID = '$downloadID'");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_download_search_form.inc");
     if($admin) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(1678)."</a>");
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(1678)."</a>");	 
     if($categoryID)
      {
       $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY."\">".wm3Download::getDownloadCategoryName($w3,$categoryID)."</a>");
       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD."\">".wm3Download::getDownloadSubcategoryName($w3,$subcategoryID)."</a>");
	   array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&downloadID=$downloadID&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD."\">".wm3Download::getDownloadName($downloadID)."</a>");
       array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $row = mysql_fetch_object($rs);
     $link = $base_link.$id_link.$search_link.$extra_link;
     if($allowed)
	  {
	   $allowed_link = $base_allowed_link."&downloadID=$row->downloadID";
	   $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DOWNLOAD,"action_edit.png",$w3->getWord(178));
      }
     else $button = "";
     $name        = "$button<b>$row->name</b> ($row->hits download from ".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage()).")";
	 $message     = $w3->getWord(1102);
	 $button      = $w3->getWord(1103)." ".wm3Util::actionButton(wm3Download::makeDownloadDirectLink($w3,$row),"action_down.png","","",$w3->getWord(1104),0,16,16).wm3Util::metaRefresh(5,wm3Download::makeDownloadDirectLink($w3,$row));
     $str .= wm3Section::makeItemList($w3,0,array(100),array($name),false);
	 $str .= wm3Section::makeItemList($w3,0,array(100),array($message),false);
	 $str .= wm3Section::makeItemList($w3,0,array(100),array($button),false);

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns,"");

     return $str;
    }

   public static function makeDownloadDirectLink($w3,$row)
    {
     // Return direct download link from $row (admin and home side)
     if($row->source == WM3_cUPLOAD_FROM_URL) return $row->download;
	 else                                     return WM3_cPATH_DOWNLOADS."$row->download";
    }

   public static function makeDownloadTime($w3,$byte,$speed)
    {
	 // Make download time informations (admin and home side)
	 $ss = floor($byte/$speed);
	 if($ss <= 300)               $pic = wm3Util::renderImg("misc_timer_fast.png");
	 if($ss > 300 && $ss <= 1200) $pic = wm3Util::renderImg("misc_timer_medium.png");
	 if($ss > 1200)               $pic = wm3Util::renderImg("misc_timer_slow.png");
	 $dd = floor($ss/86400); $ss = $ss - $dd * 86400;
	 $hh = floor($ss/3600);  $ss = $ss - $hh * 3600;
	 $mm = floor($ss/60);    $ss = $ss - $mm * 60;
	 if($ss < 10) $ss = "0".$ss;
	 if($mm < 10) $mm = "0".$mm;
	 if($hh < 10) $hh = "0".$hh;
	 $download_time = "($dd:$hh:$mm:$ss)";
	 return $pic." ".$download_time;
    }

   public static function makeDownloadInfo($w3,$byte)
    {
	 // Make download informations (admin and home side)
	 if($byte !== false)
	  {
	   $size = wm3Folder::renderFileSize($w3,$byte,$w3->getWord(1075));
	   $str = "<br><b>$size</b><br><br>".wm3Util::renderImg("misc_time.png")." ".$w3->getWord(1089)."<br><br>";
	  }
	 else
	  {
	   $str = "<br><b>".$w3->getWord(1075)." unknown</b>"; // Unknown size
	  }
	 return $str;
    }

   public static function renderDownloadTopRating($w3,$order_by,$label,$by_rate,$by_hits,$by_votes,$max_items=15,$admin=false)
    {
     // Get download top rating items list (for home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DOWNLOADS); // Used to enable admin buttons in home stage
     $filter = ""; $categoryID = 0;
     $pageID = $w3->getVariable('pageID','get');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DOWNLOAD."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DOWNLOADS;
     $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".WM3_cLANGUAGE_ALL."') ";
     if($allowed) { if($by_rate) $columns = 5; else $columns = 4; $buttons = 1; } else { if($by_rate) $columns = 4; else $columns = 3; $buttons = 0; }

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID
               $query_filter
			   $order_by
			   LIMIT 0,$max_items";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     if($by_hits)
	  {
	   require(WM3_cPATH_INCLUDE."admin_download_search_form.inc");
       array_push($_CONTENTS,$w3->getWord($label)." $_SEP <a href=\"$base_link$page_link\">".$w3->getWord(1678)."</a>");
      }
	 else
	  {
	   $search_form = "";
	   array_push($_CONTENTS,$w3->getWord($label));
	  }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();      	
	   $id_link = "&categoryID=".wm3Download::getDownloadCategoryID($w3,$row->subcategoryID)."&subcategoryID=$row->subcategoryID";
       $link = $base_link.$page_link.$id_link."&downloadID=$row->downloadID&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD;
       $n    = ($p+1).".";   

       $title  = "<a href=\"$link\">$row->name</a><br><i>".$row->description."</i>";
       if($by_rate)
	    {
	     $rating = "<nobr>".wm3Util::makeStars($w3,$row->votes_average)."</nobr>";
         $value  = "<nobr>($row->votes_average)</nobr>";
	    }
	   else
	    {
         if($by_hits)  $value = "<nobr>$row->hits hits</nobr>";
		 if($by_votes) $value = "<nobr>$row->votes_counts votes</nobr>";
		}
       if($by_rate) array_push($_CONTENTS,$n,$title,$rating,$value);
	   else         array_push($_CONTENTS,$n,$title,$value);
       if($allowed)
        {
         $allowed_link = $base_allowed_link."&downloadID=$row->downloadID&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD;
         array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DOWNLOAD,"action_edit.png",$w3->getWord(178)));
        }
       if($by_rate)  array_push($_WIDTHS,0,85,10,5);
	   else          array_push($_WIDTHS,0,90,10);
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns,"");

     return $str;
    }

   public static function hitDownload($w3)
    {
     $downloadID = $w3->getVariable('downloadID','get');
	 if(!wm3Session::downloadAllowed($downloadID,WM3_cSESSION_HIT)) return;
	 else wm3Session::downloadProtect($downloadID,WM3_cSESSION_HIT);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
                       SET    hits = hits + 1
                       WHERE  downloadID = '$downloadID'");
    }

   public static function isUsedDownloadFile($file)
    {
	 // Return true if a picture its used in a row
	 $rs = wm3Sql::sqlQuery("SELECT downloadID
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_downloads
							 WHERE  download = '$file'");
     if(mysql_num_rows($rs) == 0) return false;
	 else                         return true;
    }

  }

?>
