<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Link extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for link section
     return array(
                  'allowed_section'           => WM3_cSECTION_LINKS,
                  'category_form'             => 'admin_link_category_form.inc',
                  'search_form'               => 'admin_link_search_form.inc',
                  'table_categories'          => '_links_categories',
                  'table_subcategories'       => '_links',
                  'table_subcategories_count' => '_links',
                  'action_save_category'      => WM3_cACTION_SAVE_LINK_CATEGORY,
                  'action_update_category'    => WM3_cACTION_UPDATE_LINK_CATEGORY,
                  'action_show_subcategory'   => WM3_cACTION_SHOW_LINK,
                  'action_add_subcategory'    => WM3_cACTION_ADD_LINK,
                  'action_disable_category'   => WM3_cACTION_DISABLE_LINK_CATEGORY,
                  'action_enable_category'    => WM3_cACTION_ENABLE_LINK_CATEGORY,
                  'action_edit_category'      => WM3_cACTION_EDIT_LINK_CATEGORY,
                  'action_delete_category'    => WM3_cACTION_DELETE_LINK_CATEGORY,
                  'action_search'             => WM3_cACTION_SHOW_LINK,                  
                  'label_category_list_title' => 1677,
                  'label_subcategory_add'     => 1659,
                  'label_subcategories_count' => 1675);
				  /*,
				  'extra_button_action'       => WM3_cACTION_ADD_LINK,
				  'extra_button_icon'         => 'action_add.png',
				  'extra_button_label'        => 110);// Suggest a link (TODO)*/
    }

   public static function getLinkFieldsArray()
    {
     return array('linkID','url','title','categoryID','render_mode','description','enabled','languageID','ts');
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // Link page content
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_LINK:
        {
         return wm3Link::getLinkList($w3,0,false);
         break;
        }
       case WM3_cACTION_ADD_LINK:
        {
         return "TODO";
         break;
        }
       default:
        {
         return wm3Link::getLinkCategoryList($w3,0,false);
        }
      }     
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_LINK_CATEGORY:
        {
         return wm3Link::addLinkCategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_LINK_CATEGORY:
        {
         $error = wm3Link::checkLinkCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Link::saveLinkCategory($w3);
           // $msg= message saved... //TODO
           return wm3Link::getLinkCategoryList($w3,$lastID);
          }
         else return wm3Link::addLinkCategory($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_LINK_CATEGORY:
        {
         return wm3Link::editLinkCategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_LINK_CATEGORY:
        {
         $error = wm3Link::checkLinkCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Link::updateLinkCategory($w3);
           // $msg= message udated... //TODO
           return wm3Link::getLinkCategoryList($w3,$lastID);
          }
         else return wm3Link::editLinkCategory($w3,$error);
         break;
        }
       case WM3_cACTION_DISABLE_LINK_CATEGORY:
        {
         wm3Link::disableLinkCategory($w3->getVariable('categoryID','get'));
         return wm3Link::getLinkCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_LINK_CATEGORY:
        {
         wm3Link::enableLinkCategory($w3->getVariable('categoryID','get'));
         return wm3Link::getLinkCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_LINK_CATEGORY:
        {
         wm3Link::deleteLinkCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Link::getLinkCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_LINK:
        {
         return wm3Link::addLink($w3);
         break;
        }
       case WM3_cACTION_SAVE_LINK:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_links            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_links_categories WRITE");
         $error = wm3Link::checkLinkError($w3);
         if(!$error) {
                      $lastID = wm3Link::saveLink($w3);
           		      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Link::getLinkList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Link::addLink($w3,$error);
		             }
         break;
        }
       case WM3_cACTION_EDIT_LINK:
        {
         return wm3Link::editLink($w3);
         break;
        }
       case WM3_cACTION_UPDATE_LINK:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_links            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_links_categories WRITE");
         $error = wm3Link::checkLinkError($w3);
         if(!$error) {
                      $lastID = wm3Link::updateLink($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Link::getLinkList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Link::editLink($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_LINK:
        {
         wm3Link::disableLink($w3->getVariable('linkID','get'));
         return wm3Link::getLinkList($w3,$w3->getVariable('linkID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_LINK:
        {
         wm3Link::enableLink($w3->getVariable('linkID','get'));
         return wm3Link::getLinkList($w3,$w3->getVariable('linkID','get'));
         break;
        }
       case WM3_cACTION_DELETE_LINK:
        {
         wm3Link::deleteLink($w3->getVariable('linkID','get'));
         return wm3Link::getLinkList($w3);
         break;
        }
       case WM3_cACTION_SHOW_LINK:
        {
         return wm3Link::getLinkList($w3);
         break;
        }
       default:
        {
         return wm3Link::getLinkCategoryList($w3);
        }
      }     
    }

   public static function getLinkCategoryList($w3,$currentID = 0,$admin = true) { return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin); }

   public static function checkLinkCategoryError($w3)               { return $w3->getSectionObj()->checkCategoryError($w3); }

   public static function addLinkCategory($w3,$error = 0)           { return $w3->getSectionObj()->addCategory($w3,$error); }

   public static function editLinkCategory($w3,$error = 0)          { return $w3->getSectionObj()->editCategory($w3,$error); }

   public static function saveLinkCategory($w3)                     { return $w3->getSectionObj()->saveCategory($w3); }

   public static function updateLinkCategory($w3)                   { return $w3->getSectionObj()->updateCategory($w3); }

   public static function disableLinkCategory($categoryID)          { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_links_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'"); }

   public static function enableLinkCategory($categoryID)           { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_links_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'"); }
   
   public static function deleteLinkCategory($w3,$categoryID)       { $w3->getSectionObj()->deleteCategory($categoryID); }

   public static function selectLinkCategory($w3,$name,$categoryID,$all = false,$admin = true) { return $w3->getSectionObj()->selectCategory($w3,$name,$categoryID,$all,$admin); }

   public static function getLinkCategoryName($w3,$categoryID)      { return $w3->getSectionObj()->getCategoryName($categoryID); }

   public static function getLinkList($w3,$currentID = 0,$admin = true)
    {
     // Get link list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_LINKS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID','both');
     if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_links.categoryID = '$categoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_links.description LIKE '%$filter%'";
     	         }
     else        { if(!$categoryID) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
                 $width_title = 70;
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_LINK;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 5; $buttons = 3;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_LINK."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $width_title = 100;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_links.enabled*".WM3_cCONFIG_DB_PREFIX."_links_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_links.languageID='".$w3->getHomeLanguage()."'";
     	         if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_LINKS;
     $id_link = "&categoryID=$categoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_links.title DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_links_categories.enabled,".WM3_cCONFIG_DB_PREFIX."_links.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_links_categories,".WM3_cCONFIG_DB_PREFIX."_links
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_links_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_links.categoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'linkID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_link_search_form.inc");     
     if($admin) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(1677)."</a>");
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(1677)."</a>");
     if($categoryID)
      {
       $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_LINK."\">".wm3Link::getLinkCategoryName($w3,$categoryID)." ($total_items)</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_LINK."\">".wm3Link::getLinkCategoryName($w3,$categoryID)." ($total_items)</a>");
       if($admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_LINK,"action_add.png","","",$w3->getWord(1659),0,16,16));
       //else       array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_ADD_LINK,"action_add.png","","",$w3->getWord(110),0,16,16));//Suggest a link (TODO)
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_title,30,0),array(194,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&linkID=$row->linkID";
       if($allowed) $allowed_link = $base_allowed_link."&linkID=$row->linkID";
       if($row->title) $title = $row->title; else $title = $row->url;
	   $description = wm3Util::renderContent($w3,$row->description,$row->render_mode);
       if($categoryID) {                       
                        if($admin) array_push($_CONTENTS,"<a href=\"$row->url\" target=\"_blank\">$title</a>");
                        else       array_push($_CONTENTS,"<a href=\"$row->url\" target=\"_blank\">$title</a><br>$description");
                       }
       else            {
       	                // For the search in all categories
                        if($admin) array_push($_CONTENTS,"<a href=\"$row->url\" target=\"_blank\">$title</a><br>(".$w3->getWord(659)." <a href=\"$base_link$search_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_LINK."\">".wm3Link::getLinkCategoryName($w3,$row->categoryID)."</a>)");
                        else       array_push($_CONTENTS,"<a href=\"$row->url\" target=\"_blank\">$title</a> (".$w3->getWord(659)." <a href=\"$base_link$search_link$page_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_LINK."\">".wm3Link::getLinkCategoryName($w3,$row->categoryID)."</a>)<br>$description");
                       }
       array_push($_WIDTHS,$width_title);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         array_push($_CONTENTS,$lang_flag); array_push($_WIDTHS,30);
         // Buttons
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_LINK,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_LINK,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_LINK,"action_edit.png",$w3->getWord(178)));       
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_LINK,"action_delete.png",$w3->getWord(179),$w3->getWord(699)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_LINK,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->linkID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_LINK.$id_link.$search_link);
       else       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_LINK.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkLinkError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Link::getLinkFieldsArray());
     if(!$_FIELD['url']) return 1;
	 if(!$w3->getSectionObj()->existsCategory($_FIELD['categoryID'])) return 2;
     return 0;
    }

   public static function addLink($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Link::getLinkFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Link::getLinkFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // No url or bad url
        {
         $_STYLE['url']            = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 2: // Invalid category
        {
         $_STYLE['categoryID']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error nvalid categry";//$w3->getWord(29);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['categoryID'] = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['enabled']    = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(351);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_LINK;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_link_form.inc");
     return $content;
    }

   public static function editLink($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_links
                               WHERE linkID = '".$w3->getVariable('linkID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Link::getLinkFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Link::getLinkFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Link::getLinkFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // No url or bad url
        {
         $_STYLE['url']            = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 2: // Invalid category
        {
         $_STYLE['categoryID']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error nvalid categry";//$w3->getWord(29);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit link ...."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_LINK;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_link_form.inc");
     return $content;
    }

   public static function saveLink($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Link::getLinkFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_links',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updateLink($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Link::getLinkFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_links
                       SET url         = '".$_FIELD['url']."',
                           title       = '".$_FIELD['title']."',
                           categoryID  = '".$_FIELD['categoryID']."',
                           description = '".$_FIELD['description']."',
						   render_mode = '".$_FIELD['render_mode']."',
                           enabled     = '".$_FIELD['enabled']."',
                           languageID  = '".$_FIELD['languageID']."'
                       WHERE linkID    = '".$_FIELD['linkID']."'");
     return $_FIELD['linkID'];
    }

   public static function duplicateLink($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_links
                             WHERE linkID = '".$w3->getVariable('linkID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Link::getLinkFieldsArray(),$row);
       $_FIELD['title'] = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['ts'] = time();
       wm3Sql::saveAllTableFields('_links',$_FIELD);
       return wm3Sql::getLastInsertID();
      }
    }

   public static function disableLink($linkID) { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_links SET enabled = '".WM3_cDISABLED."' WHERE linkID = '$linkID'"); }

   public static function enableLink($linkID)  { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_links SET enabled = '".WM3_cENABLED."' WHERE linkID = '$linkID'"); }
   
   public static function deleteLink($linkID)  { wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_links WHERE linkID = '$linkID'"); }

  }

?>
