<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Message
  {

   function __construct() { }

   public static function getMessageFieldsArray()
    {
     return array('messageID','render_mode','message','enabled','languageID','update_ts','categoryID','message_ts','ts');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_MESSAGE:
        {
         wm3Message::disableMessage($w3->getVariable('messageID','get'));
         return wm3Message::getMessageList($w3,$w3->getVariable('messageID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MESSAGE:
        {
         wm3Message::enableMessage($w3->getVariable('messageID','get'));
         return wm3Message::getMessageList($w3,$w3->getVariable('messageID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MESSAGE:
        {
         wm3Message::deleteMessage($w3->getVariable('messageID','get'));
         return wm3Message::getMessageList($w3);
         break;
        }
       case WM3_cACTION_ADD_MESSAGE:
        {
         return wm3Message::addMessage($w3);
         break;
        }
       case WM3_cACTION_SAVE_MESSAGE:
        {
         $error = wm3Message::checkMessageError($w3);
         if(!$error)
          {
           $lastID = wm3Message::saveMessage($w3);
           // $msg= message saved... //TODO
           return wm3Message::getMessageList($w3,$lastID);
          }
         else return wm3Message::addMessage($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_MESSAGE:
        {
         return wm3Message::editMessage($w3);
         break;
        }
       case WM3_cACTION_UPDATE_MESSAGE:
        {
         $error = wm3Message::checkMessageError($w3);
         if(!$error)
          {
           $lastID = wm3Message::updateMessage($w3);
           // $msg= message udated... //TODO
           return wm3Message::getMessageList($w3,$lastID);
          }
         else return wm3Message::editMessage($w3,$error);
         break;
        }
       case WM3_cACTION_DUPLICATE_MESSAGE:
        {
         $lastID = wm3Message::duplicateMessage($w3);
         // $msg= message duplicated... //TODO
         return wm3Message::getMessageList($w3,$lastID);
         break;
        }
       default:
        {
         return wm3Message::getMessageList($w3);
        }
      }
    }

   public static function getMessageList($w3,$currentID = 0,$admin = true)
    {
     // Get messages list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     if($admin)
      {
       $width_message = 70;
	   $search_form_link = WM3_cCONFIG_ADMIN_FILE;
       $columns = 6; $buttons = 4;
      }
     else
      {
       $width_message = 100;
       if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
       $query_filter .= "enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'";
       if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_messages.message_ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'messageID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0 && $admin) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array(); $search_form = "";
     if($admin)
      {
       require(WM3_cPATH_INCLUDE."admin_message_search_form.inc");
       array_push($_CONTENTS,$w3->getWord(1142));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_message,30,0),array(228,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&messageID=$row->messageID";
       if($allowed) $allowed_link = $base_allowed_link."&messageID=$row->messageID";
       array_push($_CONTENTS,wm3Util::renderContent($w3,$row->message,$row->render_mode)); array_push($_WIDTHS,$width_message);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         array_push($_CONTENTS,$lang_flag); array_push($_WIDTHS,30);
         // Buttons
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_MESSAGE,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_MESSAGE,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MESSAGE,"action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DUPLICATE_MESSAGE,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_MESSAGE,"action_delete.png",$w3->getWord(179),$w3->getWord(774)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MESSAGE,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->messageID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
	   if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkMessageError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Message::getMessageFieldsArray());
     if(!$_FIELD['message']) return 1;
     return 0;
    }

   public static function addMessage($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Message::getMessageFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Message::getMessageFieldsArray());
     // Fields for paging default value
     $pg = $filter = ''; 
     switch($error)
      {
       case 1: // Empty message 
        {
         $_STYLE['message']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(132);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled']   = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(351);
       	}
      }
	 $_EXTRA['update_ts'] = '';
     $next_action       = WM3_cACTION_SAVE_MESSAGE;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_message_form.inc");
     return $content;
    }

   public static function editMessage($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages
                               WHERE messageID = '".$w3->getVariable('messageID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Message::getMessageFieldsArray(),$row);
       // Default value for fields not in $row object
       $_FIELD['update_ts'] = "";
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Message::getMessageFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Message::getMessageFieldsArray());
     $_EXTRA['update_ts'] = wm3Section::makeFormItem($w3,$_STYLE['update_ts'],$w3->getWord(327),wm3Util::checkboxEnabled('update_ts',$_FIELD['update_ts']));
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // No message 
        {
         $_STYLE['message']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(132);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(130);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_MESSAGE;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_message_form.inc");
     return $content;
    }

   public static function saveMessage($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Message::getMessageFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['message_ts'] = $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_messages',$_FIELD,array('update_ts'));
     return wm3Sql::getLastInsertID();
    }

   public static function updateMessage($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Message::getMessageFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['update_ts']) $message_ts = time(); else $message_ts = $_FIELD['message_ts'];     
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_messages
                       SET message     = '".$_FIELD['message']."',
					       render_mode = '".$_FIELD['render_mode']."',
                           message_ts  = '$message_ts',
                           enabled     = '".$_FIELD['enabled']."',
                           languageID  = '".$_FIELD['languageID']."'
                       WHERE messageID = '".$_FIELD['messageID']."'");
     return $_FIELD['messageID'];
    }

   public static function selectMessage($name,$messageID)
    {
     // Make message categories select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages");
     $str = "<select name=\"$name\">";
     while($row = mysql_fetch_object($rs))
      {
       if($row->messageID == $messageID) $str .= wm3Util::inputOption($row->arg_name,$row->arg_blockID,"selected");
       else                              $str .= wm3Util::inputOption($row->arg_name,$row->arg_blockID);
      }
     $str .= "</select>";
     return $str;
    }

   public static function duplicateMessage($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages
                             WHERE messageID = '".$w3->getVariable('messageID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Message::getMessageFieldsArray(),$row,WM3_cQUOTE_DB);
       $_FIELD['message'] = $w3->getWord(1417).$_FIELD['message'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['update_ts'] = $_FIELD['ts'] = time();
       wm3Sql::saveAllTableFields('_messages',$_FIELD,array('update_ts'));
       return wm3Sql::getLastInsertID();
      }
    }

   public static function disableMessage($messageID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_messages SET enabled = '".WM3_cDISABLED."' WHERE messageID = '$messageID'");
	}

   public static function enableMessage($messageID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_messages SET enabled = '".WM3_cENABLED."' WHERE messageID = '$messageID'");
	}
   
   public static function deleteMessage($messageID)
    {
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_messages WHERE messageID = '$messageID'");
	}

  }

?>
