<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3News extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for news section
     return array(
                  'allowed_section'           => WM3_cSECTION_LINKS,
                  'category_form'             => 'admin_news_category_form.inc',
                  'search_form'               => 'admin_news_search_form.inc',
                  'table_categories'          => '_news_categories',
                  'table_subcategories'       => '_news',
                  'table_subcategories_count' => '_news',
                  'action_save_category'      => WM3_cACTION_SAVE_NEWS_CATEGORY,
                  'action_update_category'    => WM3_cACTION_UPDATE_NEWS_CATEGORY,
                  'action_show_subcategory'   => WM3_cACTION_SHOW_NEWS,
                  'action_add_subcategory'    => WM3_cACTION_ADD_NEWS,
                  'action_disable_category'   => WM3_cACTION_DISABLE_NEWS_CATEGORY,
                  'action_enable_category'    => WM3_cACTION_ENABLE_NEWS_CATEGORY,
                  'action_edit_category'      => WM3_cACTION_EDIT_NEWS_CATEGORY,
                  'action_delete_category'    => WM3_cACTION_DELETE_NEWS_CATEGORY,
                  'action_search'             => WM3_cACTION_SHOW_NEWS,
                  'label_category_list_title' => 833,
                  'label_subcategory_add'     => 1654,
                  'label_subcategories_count' => 1679);
    }

   public static function getNewsFieldsArray()
    {
     return array('newsID','title','categoryID','userID','render_mode','news','enabled','languageID','update_ts','hits','news_ts','ts');
    }

   public static function getNewsCommentFieldsArray()
    {
     return array('commentID','render_mode','comment','newsID','userID','enabled','languageID','ts');
    }

   public static function executeHomeAction($w3)
    {
     // News page content
     switch($w3->getAction())
      {
       case WM3_cACTION_SAVE_NEWS_COMMENT:
        {
         $error = wm3News::checkNewsCommentError($w3);
         if(!$error)
          {
           $lastID = wm3News::saveNewsComment($w3);
           // $msg= message saved... //TODO
          }
         return wm3News::renderSingleNews($w3,true,$error);
         break;
        }
       case WM3_cACTION_SHOW_SINGLE_NEWS:
        {
         wm3News::hitNews($w3);			
         return wm3News::renderSingleNews($w3);
         break;
        }
       case WM3_cACTION_PRINTABLE_SINGLE_NEWS:
        {
         wm3News::renderSingleNewsPrintable($w3);
         break;
        }
       default:
        {
         return wm3News::renderAllNews($w3);
        }
      }     
    }

   public static function executeUserAction($w3,$full)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_NEWS:
        {
         return wm3News::addNews($w3,0,true,$full);
         break;
        }
       case WM3_cACTION_SAVE_NEWS:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_news            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_news_categories WRITE");
         $error = wm3News::checkNewsError($w3,true);
         if(!$error) {
                      $lastID = wm3News::saveNews($w3,true,$full);
		              wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3News::getNewsList($w3,$lastID,true,true,$full);
                     }
         else        {
		              wm3Sql::sqlQuery("UNLOCK TABLES");
		              return wm3News::addNews($w3,$error,true,$full);
		             }
         break;
        }
       case WM3_cACTION_EDIT_NEWS:
        {
         return wm3News::editNews($w3,0,true,$full);
         break;
        }
       case WM3_cACTION_UPDATE_NEWS:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_news            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_news_categories WRITE");
         $error = wm3News::checkNewsError($w3,true);
         if(!$error) {
                      $lastID = wm3News::updateNews($w3,true,$full);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3News::getNewsList($w3,$lastID,true,true,$full);
                     }
         else        {
		              wm3Sql::sqlQuery("UNLOCK TABLES");
		              return wm3News::editNews($w3,$error,true,$full);
	                 }
         break;
        }
       case WM3_cACTION_DISABLE_NEWS:
        {
         wm3News::disableNews($w3,$w3->getVariable('newsID','get'),true,$full);
         return wm3News::getNewsList($w3,$w3->getVariable('newsID','get'),true,true,$full);
         break;
        }
       case WM3_cACTION_ENABLE_NEWS:
        {
         wm3News::enableNews($w3,$w3->getVariable('newsID','get'),true,$full);
         return wm3News::getNewsList($w3,$w3->getVariable('newsID','get'),true,true,$full);
         break;
        }
       case WM3_cACTION_DELETE_NEWS:
        {
         wm3News::deleteNews($w3,$w3->getVariable('newsID','get'),true,$full);
         return wm3News::getNewsList($w3,0,true,true,$full);
         break;
        }
       /*case WM3_cACTION_DUPLICATE_NEWS:
        {
         $lastID = wm3News::duplicateNews($w3);
         // $msg= message duplicated... //TODO
         return wm3News::getNewsList($w3,$lastID,true,true,$full);
         break;
        }*/
       default:
        {
         return wm3News::getNewsList($w3,0,true,true,$full);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_NEWS_CATEGORY:
        {
         return wm3News::addNewsCategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_NEWS_CATEGORY:
        {
         $error = wm3News::checkNewsCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3News::saveNewsCategory($w3);
           // $msg= message saved... //TODO
           return wm3News::getNewsCategoryList($w3,$lastID);
          }
         else return wm3News::addNewsCategory($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_NEWS_CATEGORY:
        {
         return wm3News::editNewsCategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_NEWS_CATEGORY:
        {
         $error = wm3News::checkNewsCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3News::updateNewsCategory($w3);
           // $msg= message udated... //TODO
           return wm3News::getNewsCategoryList($w3,$lastID);
          }
         else return wm3News::editNewsCategory($w3,$error);
         break;
        }
       case WM3_cACTION_DISABLE_NEWS_CATEGORY:
        {
         wm3News::disableNewsCategory($w3->getVariable('categoryID','get'));
         return wm3News::getNewsCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_NEWS_CATEGORY:
        {
         wm3News::enableNewsCategory($w3->getVariable('categoryID','get'));
         return wm3News::getNewsCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_NEWS_CATEGORY:
        {
         wm3News::deleteNewsCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3News::getNewsCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_NEWS:
        {
         return wm3News::addNews($w3);
         break;
        }
       case WM3_cACTION_SAVE_NEWS:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_news            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_news_categories WRITE");
         $error = wm3News::checkNewsError($w3);
         if(!$error) {
                      $lastID = wm3News::saveNews($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3News::getNewsList($w3,$lastID);
                     }
         else        {
		              wm3Sql::sqlQuery("UNLOCK TABLES");
		              return wm3News::addNews($w3,$error);
	                 }
         break;
        }
       case WM3_cACTION_EDIT_NEWS:
        {
         return wm3News::editNews($w3);
         break;
        }
       case WM3_cACTION_UPDATE_NEWS:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_news            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_news_categories WRITE");
         $error = wm3News::checkNewsError($w3);
         if(!$error) {
                      $lastID = wm3News::updateNews($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3News::getNewsList($w3,$lastID);
                     }
         else        {
                      wm3Sql::sqlQuery("UNLOCK TABLES");
		              return wm3News::editNews($w3,$error);
	                 }
         break;
        }
       case WM3_cACTION_DISABLE_NEWS:
        {
         wm3News::disableNews($w3,$w3->getVariable('newsID','get'));
         return wm3News::getNewsList($w3,$w3->getVariable('newsID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_NEWS:
        {
         wm3News::enableNews($w3,$w3->getVariable('newsID','get'));
         return wm3News::getNewsList($w3,$w3->getVariable('newsID','get'));
         break;
        }
       case WM3_cACTION_DELETE_NEWS:
        {
         wm3News::deleteNews($w3,$w3->getVariable('newsID','get'));
         return wm3News::getNewsList($w3);
         break;
        }
       case WM3_cACTION_DUPLICATE_NEWS:
        {
         $lastID = wm3News::duplicateNews($w3);
         // $msg= message duplicated... //TODO
         return wm3News::getNewsList($w3,$lastID);
         break;
        }
       case WM3_cACTION_SHOW_NEWS:
        {
         return wm3News::getNewsList($w3);
         break;
        }
       default:
        {
         return wm3News::getNewsCategoryList($w3);
        }
      }     
    }

   public static function renderCommentNews($w3)
    {
     // Render comments list for a single news in home page

     // Prepare variables to create the list
     $max_page_items = 12;
     $columns = 3;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID','both');
     $newsID     = $w3->getVariable('newsID','both');
     $pg         = '';// $w3->getVariable('pg','both'); //TODO Visualizzare tutti i commenti su unica pagina oppure su piu' pagine? (in tal caso non confondere $pg delle notizie con il $pg (che va quindi rinominato) dei commenti)
     $query_filter = " WHERE newsID='$newsID' AND enabled='".WM3_cENABLED."'";
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";

     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_NEWS;
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_NEWS;

     // Do the query and take the total items number
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_news_comments
               $query_filter"; // TODO Join per categorie disabled

     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     //if($total_items != 0) $rs = wm3Sql::sqlQuery($query."ORDER BY ".WM3_cCONFIG_DB_PREFIX."_news_comments.ts DESC LIMIT ".($pg*$max_page_items).",$max_page_items");//TODO decommentare questa riga se si vogliono visualizzare i commenti su piu' pagine
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query."ORDER BY ".WM3_cCONFIG_DB_PREFIX."_news_comments.ts DESC");//TODO togliere questa riga se si vogliono visualizzare i commenti su piu' pagine

     // Create list header
     $_CONTENTS = array();
     array_push($_CONTENTS,$w3->getWord(559));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // List items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$extra_link."&newsID=$row->newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
       $pic  = wm3User::getAvatar($row->userID);
       $date = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
       if($allowed) $allowed_link = $base_allowed_link."&newsID=$row->newsID";
       array_push($_CONTENTS,"<div align=\"center\"><img src=\"$pic\" border=\"\" width=\"36\" height=\"36\"><br>".wm3User::getUserLogin($row->userID)."</div></td>");
       array_push($_CONTENTS,"<i>$date</i><br>".wm3Util::renderContent($w3,$row->comment,$row->render_mode)."</td>");
       if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_NEWS,"action_delete.png",$w3->getWord(178)));
       array_push($_WIDTHS,0,100);
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;       
      }

     // Create list bottom
     $bottom_content = "";

     /*if($total_items > $max_page_items)//TODO decommentare se si vogliono visualizzare i commenti su piu' pagine
      {
       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link);
      }*/

     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);
     
     return $str;
    }

   public static function renderSingleNewsPrintable($w3)
    {
     // Render a single printable news

     // Prepare variables to create the list
     $categoryID = $w3->getVariable('categoryID','both');
     $newsID     = $w3->getVariable('newsID','both');
     $query_filter = " WHERE enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_news.languageID='".$w3->getHomeLanguage()."'";
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.newsID = '$newsID'";

     // Do the query and take the total items number
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_news
               $query_filter";// TODO Join per categorie disabled

     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Render News
     $row = mysql_fetch_object($rs);
	 if(!$row)
	  {
	   // TODO fare meglio
	   $title = $subtitle = "&nbsp;";
	   $content = wm3Section::makeNotFoundItem($w3);
      }
	 else
	  {
       $title    = wm3Util::renderContent($w3,$row->title,$row->render_mode);
       $content  = wm3Util::renderContent($w3,$row->news,$row->render_mode,true);
	   $subtitle = wm3Util::renderDate($w3,$row->news_ts,$w3->getHomeLanguage(),true,'',false)." (newsID #".$row->newsID.")";;
      }
	 require($w3->getSkinObj()->getPage($w3));
    }

   public static function renderSingleNews($w3,$comment_inserted = false, $error = 0)
    {
     // Render a single news with comments in home page

     // Prepare variables to create the list
     $max_page_items = 3;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID','both');
     $newsID     = $w3->getVariable('newsID','both');
     $pg         = $w3->getVariable('pg','both');
     $query_filter = " WHERE enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_news.languageID='".$w3->getHomeLanguage()."'";
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.newsID = '$newsID'";
     if($pg) $extra_link  = "&pg=$pg"; else $extra_link = "";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_NEWS;
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_NEWS;

     // Do the query and take the total items number
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_news
               $query_filter";// TODO Join per categorie disabled

     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
//     if($total_items != 0) $rs = wm3Sql::sqlQuery($query."ORDER BY ".WM3_cCONFIG_DB_PREFIX."_news.news_ts DESC LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Render News
     $row = mysql_fetch_object($rs);
	 if(!$row)
	  {
	   // TODO fare meglio
	   $title = $info = $icon = $hits = $comments = $comments_form = "&nbsp;";
	   $content = wm3Section::makeNotFoundItem($w3);
      }
	 else
	  {
       $link = $base_link.$extra_link."&newsID=$row->newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
       if($allowed) $allowed_link = $base_allowed_link."&newsID=$row->newsID";
       if($allowed) $allowed_button = " ".wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_NEWS,"action_edit.png",$w3->getWord(178)); else $allowed_button = "";
       $icon_file = $w3->getSectionObj()->getCategoryIcon($row->categoryID);
	   $author = " ".$w3->getWord(232)." <a href=\"$base_link&userID=$row->userID\">".wm3User::getUserLogin($row->userID)."</a>";
       $comments = wm3News::makeCounterCommentNews($w3,$row->newsID);
       $date = wm3Util::renderDate($w3,$row->news_ts,$w3->getHomeLanguage());

       $printable_button = wm3Util::actionButton($base_link.$extra_link."&newsID=$row->newsID&action=".WM3_cACTION_PRINTABLE_SINGLE_NEWS,"action_print.png",$w3->getWord(1400),"","",0,24,24,"absmiddle","_blank");
       $title = "<a href=\"$link\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a>".$allowed_button;
       $info = $date.$author.$comments;
       $icon = "<a href=\"$base_link&categoryID=$row->categoryID\"><img src=\"".WM3_cPATH_ICONS."$icon_file\" width=\"36\" height=\"36\" border=\"0\"></a>";
       $content = wm3Util::renderContent($w3,$row->news,$row->render_mode,true);
       $hits = "$printable_button <b>Read $row->hits times</b>";
	   if($w3->getPreferences('enable_news_comments'))
	    {
         $comments = wm3News::renderCommentNews($w3); // Comments list
		 if($w3->getPreferences('anonymous_news_comments') || $w3->getAuthenticateAdminUserID() != WM3_cUSER_ANONYMOUS)
          $comments_form = wm3News::addNewsComment($w3,$comment_inserted,$error); // Add comment form
		 else $comments_form = "&nbsp;";
	    }
	   else $comments = $comments_form = "&nbsp;";
      }
     require($w3->getSkinObj()->getNews($w3->getPreferences('enable_news_comments'))); 
    }

   public static function renderAllNews($w3)
    {
     // Render news list in home page

     // Prepare variables to create the list
     $max_page_items = $w3->getPreferences('home_news_max');
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID','both');
	 $userID     = $w3->getVariable('userID','both');
     $pg         = $w3->getVariable('pg','both');
     $query_filter = " WHERE enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_news.languageID='".$w3->getHomeLanguage()."'";
     if($categoryID) $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.categoryID = '$categoryID'";
	 if($userID)     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.userID = '$userID'";
     if($pg) $extra_link  = "&pg=$pg"; else $extra_link = "";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_NEWS;
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_NEWS;

     // Do the query and take the total items number
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_news
               $query_filter";// TODO Join per categorie disabled
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query."ORDER BY ".WM3_cCONFIG_DB_PREFIX."_news.news_ts DESC LIMIT ".($pg*$max_page_items).",$max_page_items");

     // News list
	 if($total_items != 0)
	  {
	   $all_rss = wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_RSS."&languageID=".$w3->getHomeLanguage(),"misc_rss_big.png",'','',$w3->getWord(-1)."RSS Feed",0,16,16);
	   $title   = $w3->getSkinObj()->getLeftPageTitle().$w3->getWord(567).$w3->getSkinObj()->getRightPageTitle();
	   $content = $all_rss;
	   require($w3->getSkinObj()->getNewsHead());
      }
     while($row = mysql_fetch_object($rs))
      {
       $link = $base_link.$extra_link."&newsID=$row->newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
       if($allowed) $allowed_link = $base_allowed_link."&newsID=$row->newsID";       

       // Render news
       if($allowed) $allowed_button = " ".wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_NEWS,"action_edit.png",$w3->getWord(178)); else $allowed_button = "";
       $icon_file = $w3->getSectionObj()->getCategoryIcon($row->categoryID);
       $author = " ".$w3->getWord(232)." <a href=\"$base_link&userID=$row->userID\">".wm3User::getUserLogin($row->userID)."</a>";
       $comments = wm3News::makeCounterCommentNews($w3,$row->newsID);
       $date = wm3Util::renderDate($w3,$row->news_ts,$w3->getHomeLanguage());

       $title = "<a href=\"$link\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a>".$allowed_button;
       $info = $date.$author.$comments;
       $icon = "<a href=\"$base_link&categoryID=$row->categoryID\"><img src=\"".WM3_cPATH_ICONS."$icon_file\" width=\"36\" height=\"36\" border=\"0\"></a>";
       $content = wm3Util::renderContent($w3,$row->news,$row->render_mode,true,$link);
       $hits = "Read $row->hits times";
       $comments = $comments_form = "";
       require($w3->getSkinObj()->getNews());
      }

     // Create page navigator
     if($total_items > $max_page_items)
      {
       $bottom = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&userID=$userID&categoryID=$categoryID");
       require($w3->getSkinObj()->getNewsBottom());
      }
    }

   public static function getNewsCategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin);
    }

   public static function checkNewsCategoryError($w3)
    {
   	 return $w3->getSectionObj()->checkCategoryError($w3);
    }

   public static function addNewsCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editNewsCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function saveNewsCategory($w3)
    {
     return $w3->getSectionObj()->saveCategory($w3);
    }

   public static function updateNewsCategory($w3)
    {
     return $w3->getSectionObj()->updateCategory($w3);
    }

   public static function disableNewsCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableNewsCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteNewsCategory($w3,$categoryID)
    {
     $w3->getSectionObj()->deleteCategory($categoryID);
    }

   public static function selectNewsCategory($w3,$name,$categoryID,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$name,$categoryID,$all,$admin);
    }

   public static function getNewsCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($categoryID);
    }

   public static function getNewsList($w3,$currentID = 0,$admin = true,$user = false,$full = false)
    {
     // Get news list (admin and user side)

     // $full its true when an user can have full control for own news
     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID','both');
     if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_news.categoryID = '$categoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.news LIKE '%$filter%'";
     	         }
     else        { if(!$categoryID) if(!$user) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
                 $width_title = 70;
	             if(!$user) $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_NEWS;
	             else       $search_form_link = WM3_cCONFIG_USER_FILE;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 5; $buttons = 3;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_NEWS."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $width_title = 100;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.enabled*".WM3_cCONFIG_DB_PREFIX."_news_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_news.languageID='".$w3->getHomeLanguage()."'";
     	         if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_NEWS;
     $id_link = "&categoryID=$categoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_news.news_ts DESC";
     if(!$user)
	  {	 
       $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_news_categories.enabled,".WM3_cCONFIG_DB_PREFIX."_news.*
                 FROM   ".WM3_cCONFIG_DB_PREFIX."_news_categories,".WM3_cCONFIG_DB_PREFIX."_news
                 WHERE  ".WM3_cCONFIG_DB_PREFIX."_news_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_news.categoryID
                 $query_filter";
      }
	 else
	  {
       $query = "SELECT *
                 FROM   ".WM3_cCONFIG_DB_PREFIX."_news
                 WHERE  userID = '".$w3->getAuthenticateUserID()."'
                 $query_filter";
	  }
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
	 if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'newsID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_link_search_form.inc");
     if($admin)
	  {
	   if(!$user) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(833)."</a>");
	   else       array_push($_CONTENTS,$w3->getWord(833));
      }
     else array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(833)."</a>");
     if($categoryID && !$user)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_NEWS."\">".wm3News::getNewsCategoryName($w3,$categoryID)." ($total_items)</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_NEWS."\">".wm3News::getNewsCategoryName($w3,$categoryID)." ($total_items)</a>");
       if($admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_NEWS,"action_add.png","","",$w3->getWord(1654),0,16,16));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_title,30,0),array(194,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&newsID=$row->newsID";
       if($allowed) $allowed_link = $base_allowed_link."&newsID=$row->newsID";
	   $date = wm3Util::renderDate($w3,$row->news_ts,$w3->getHomeLanguage());
       if($categoryID) {                       
                        if($admin) array_push($_CONTENTS,wm3Util::renderContent($w3,$row->title,$row->render_mode)."<br>$date");
                        else       array_push($_CONTENTS,wm3Util::renderContent($w3,$row->title,$row->render_mode)." ($row->hits hits)<br>$row->news");
                       }
       else            {
		                // For the search in all categories
                        if($admin)
						 {
						  if(!$user) array_push($_CONTENTS,wm3Util::renderContent($w3,$row->title,$row->render_mode)."<br>$date<br>(".$w3->getWord(659)." <a href=\"$base_link$search_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_NEWS."\">".wm3News::getNewsCategoryName($w3,$row->categoryID)."</a>)");
						  else       array_push($_CONTENTS,wm3Util::renderContent($w3,$row->title,$row->render_mode)."<br>(".$w3->getWord(659)." ".wm3News::getNewsCategoryName($w3,$row->categoryID).")");
					     }
                        else array_push($_CONTENTS,wm3Util::renderContent($w3,$row->title,$row->render_mode)." ($row->hits hits) (".$w3->getWord(659)." <a href=\"$base_link$search_link$page_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_NEWS."\">".wm3News::getNewsCategoryName($w3,$row->categoryID)."</a>)<br>$row->news");
                       }
       array_push($_WIDTHS,$width_title);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 if(wm3User::checkAdminPermission($w3,WM3_cSECTION_USERS)) $author = " ".$w3->getWord(232)." <a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USERS."&userID=$row->userID&action=".WM3_cACTION_EDIT_USER."\">".wm3User::getUserLogin($row->userID)."</a>";
		 else                                                      $author = " ".$w3->getWord(232)." ".wm3User::getUserLogin($row->userID);
		 $hits      = "<br>($row->hits hits)";
		 $info = $lang_flag.$author.$hits;
         array_push($_CONTENTS,$info); array_push($_WIDTHS,30);
         // Buttons
         if($row->enabled)
		  {
		   if($user && !$full) array_push($_CONTENTS,"<img src=\"".WM3_cPATH_DATA."action_disable_inactive.png\"");
		   else                array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_NEWS,"action_disable.png",$w3->getWord(180)));
		  }
         else
		  {
		   if($user && !$full) array_push($_CONTENTS,"<img src=\"".WM3_cPATH_DATA."action_enable_inactive.png\"");
		   else                array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_NEWS,"action_enable.png",$w3->getWord(181)));
	      }		 
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_NEWS,"action_edit.png",$w3->getWord(178)));
         if($user && !$full) array_push($_CONTENTS,"<img src=\"".WM3_cPATH_DATA."action_delete_inactive.png\"");
		 else                array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_NEWS,"action_delete.png",$w3->getWord(179),$w3->getWord(772)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_NEWS,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->newsID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_NEWS.$id_link.$search_link);
       else       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_NEWS.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkNewsError($w3,$user = false)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsFieldsArray());
     if(!$_FIELD['title']) return 1;
	 if(!$w3->getSectionObj()->existsCategory($_FIELD['categoryID'])) return 2;
     if(!$_FIELD['news']) return 3;
     return 0;
    }

   public static function addNews($w3,$error = 0,$user = false,$full = false)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3News::getNewsFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsFieldsArray());
	 $_EXTRA['update_ts']  = '';
     // Fields for paging default value
     $pg = $filter = "";
     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 2: // Invalid category
        {
         $_STYLE['categoryID'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']  = WM3_cSKIN_ERROR;
         $form_title = "Error $error nvalid categry";//$w3->getWord(29);
         break;
        }
       case 3: // No news
        {
         $_STYLE['news']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['categoryID'] = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['enabled']    = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(347);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_NEWS;
     $next_action_label = $w3->getWord(191);
     if($user) if($full) require(WM3_cPATH_INCLUDE."user_news_full_form.inc");
	           else      require(WM3_cPATH_INCLUDE."user_news_form.inc");
	 else      require(WM3_cPATH_INCLUDE."admin_news_form.inc");
     return $content;
    }

   public static function editNews($w3,$error = 0,$user = false,$full = false)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_news
                               WHERE newsID = '".$w3->getVariable('newsID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3News::getNewsFieldsArray(),$row);
       // Default value for fields not in $row object
       $_FIELD['update_ts'] = "";
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3News::getNewsFieldsArray());
     $_EXTRA['update_ts'] = wm3Section::makeFormItem($w3,$_STYLE['update_ts'],$w3->getWord(327),wm3Util::checkboxEnabled('update_ts',$_FIELD['update_ts']));
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 2: // Invalid category
        {
         $_STYLE['categoryID'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']  = WM3_cSKIN_ERROR;
         $form_title = "Error $error nvalid categry";//$w3->getWord(29);
         break;
        }
       case 3: // No news
        {
         $_STYLE['news']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
	   default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit news ...."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_NEWS;
     $next_action_label = $w3->getWord(29);
     if($user) if($full) require(WM3_cPATH_INCLUDE."user_news_full_form.inc");
	           else      require(WM3_cPATH_INCLUDE."user_news_form.inc");
	 else      require(WM3_cPATH_INCLUDE."admin_news_form.inc");	 
     return $content;
    }

   public static function saveNews($w3,$user = false,$full = false)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['news_ts'] = $_FIELD['ts'] = time();
     $_FIELD['hits'] = 0;
	 if($user) {
		        $_FIELD['userID'] = $w3->getAuthenticateUserID();
				if($_FIELD['render_mode'] == WM3_cRENDER_MODE_HTML ||
				   $_FIELD['render_mode'] == WM3_cRENDER_MODE_HTML_BB_CODE)
				$_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;				 
	            if(!$full) $_FIELD['enabled'] = WM3_cDISABLED;
			   }
     wm3Sql::saveAllTableFields('_news',$_FIELD,array('update_ts'));
     return wm3Sql::getLastInsertID();
    }

   public static function updateNews($w3,$user = false,$full = false)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['update_ts']) $news_ts = time(); else $news_ts = wm3News::getNewsTS($_FIELD['newsID']);     
	 if($user) {
		        $userID = $w3->getAuthenticateUserID();
				if($_FIELD['render_mode'] == WM3_cRENDER_MODE_HTML ||
				   $_FIELD['render_mode'] == WM3_cRENDER_MODE_HTML_BB_CODE)
				 $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
				if(!$full) $_FIELD['enabled'] = WM3_cDISABLED;
		       }
	 else      $userID = $_FIELD['userID'];
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news
                       SET title       = '".$_FIELD['title']."',
                           categoryID  = '".$_FIELD['categoryID']."',
                           userID      = '$userID',
						   render_mode = '".$_FIELD['render_mode']."',
                           news        = '".$_FIELD['news']."',
                           news_ts     = '$news_ts',
                           enabled     = '".$_FIELD['enabled']."',
                           languageID  = '".$_FIELD['languageID']."'
                       WHERE newsID    = '".$_FIELD['newsID']."'");
     return $_FIELD['newsID'];
    }

   public static function duplicateNews($w3)
    {
     // Take fields from database and duplicate data creating a new row
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_news            WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_news_categories WRITE");
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_news
                             WHERE newsID = '".$w3->getVariable('newsID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3News::getNewsFieldsArray(),$row);
       $_FIELD['title'] = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['update_ts'] = $_FIELD['ts'] = time();
       $_FIELD['ts'] = time();
       wm3Sql::saveAllTableFields('_news',$_FIELD,array('update_ts'));
	   wm3Sql::sqlQuery("UNLOCK TABLES");
       return wm3Sql::getLastInsertID();
      }
	 wm3Sql::sqlQuery("UNLOCK TABLES");
    }

   public static function disableNews($w3,$newsID,$user = false,$full = false)
    {
	 if($user) { if($full) wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news SET enabled = '".WM3_cDISABLED."' WHERE newsID = '$newsID' AND userID='".$w3->getAuthenticateUserID()."'"); }
	 else      { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news SET enabled = '".WM3_cDISABLED."' WHERE newsID = '$newsID'"); }
	}

   public static function enableNews($w3,$newsID,$user = false,$full = false)
    {
	 if($user) { if($full) wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news SET enabled = '".WM3_cENABLED."' WHERE newsID = '$newsID' AND userID='".$w3->getAuthenticateUserID()."'"); }
	 else      { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news SET enabled = '".WM3_cENABLED."' WHERE newsID = '$newsID'"); }
	}

   public static function deleteNews($w3,$newsID,$user = false,$full = false)
    {
     if($user) { if($full) wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_news WHERE newsID = '$newsID' AND userID='".$w3->getAuthenticateUserID()."'"); }
	 else      { wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_news WHERE newsID = '$newsID'"); }
	}

   public static function checkNewsCommentError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsCommentFieldsArray());
     if(!$_FIELD['comment']) return 1;
	 if(wm3Captcha::canUseCaptcha())
	  if(!wm3Captcha::testPassedCaptcha($w3)) return 2;
     return 0;
    }

   public static function addNewsComment($w3,$comment_inserted,$error)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3News::getNewsCommentFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsCommentFieldsArray());
     $_STYLE['captcha'] = 1;
     // Fields for paging default value
     $pg = $filter = "";
     switch($error)
      {
       case 1: // No comment
        {
         $_STYLE['comment']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(132);
         break;
        }
       case 2: // Captcha check fails
        {
         $_STYLE['captcha']   = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Bad captcha";//$w3->getWord(444);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['newsID']  = $w3->getVariable('newsID','both'); // Take newsID from both
         $_FIELD['comment'] = '';

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         if($comment_inserted) $form_title = "Comment inserted!";//$w3->getWord(-1);
         else                  $form_title = $w3->getWord(1119);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_NEWS_COMMENT;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."home_news_comment_form.inc");
     return $home_content;
    }

   public static function saveNewsComment($w3)
    {
	 if(!$w3->getPreferences('enable_news_comments')) return 0;
     if(wm3Session::actionAllowed($w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3->getVariable('_ID','post'));
       $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsCommentFieldsArray(),WM3_cQUOTE_DB);
	   $userID = $w3->getAuthenticateAdminUserID();
       $_FIELD['ts']      = time();
       $_FIELD['userID']  = $userID;
       $_FIELD['enabled'] = WM3_cENABLED;
       if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	      $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	    $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
	   //$_FIELD['languageID'] = ???;
	   if($userID == WM3_cUSER_ANONYMOUS && !$w3->getPreferences('anonymous_news_comments')) return 0;
	   else wm3Sql::saveAllTableFields('_news_comments',$_FIELD);
	   return wm3Sql::getLastInsertID();
      } 
     return 0;
    }

   public static function makeCounterCommentNews($w3,$newsID)
    {
     // Get the number of comments for a news
     $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_news_comments","WHERE newsID = '$newsID' AND enabled='".WM3_cENABLED."'");
     if($total == 1) $label = $w3->getWord(1116); else $label = $w3->getWord(1115);
     return " ($total $label)";
    }

   public function renderRssNews($w3)
    {
     // Render rss for all news (home side)

     // Prepare variables to create the list
     $max_page_items = $w3->getPreferences('home_news_max');
	 $languageID = $w3->getVariable('languageID','both');
	 $query_filter = " WHERE enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_news.languageID='$languageID'";
	 if($w3->getAction() == WM3_cACTION_SHOW_RSS_CATEGORY)
	  {
       $categoryID = $w3->getVariable('categoryID','both');
       $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.categoryID = '$categoryID'";
      }
	 if($w3->getAction() == WM3_cACTION_SHOW_RSS_AUTHOR)
      {
       $userID = $w3->getVariable('userID','both');
	   $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.userID = '$userID'";
      }
	 $extra_link = "";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_NEWS;

     // Do the query and take the total items number
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_news
               $query_filter";// TODO Join per categorie disabled
     $rs = wm3Sql::sqlQuery($query." ORDER BY ".WM3_cCONFIG_DB_PREFIX."_news.news_ts DESC LIMIT 0, $max_page_items");

     // Rss header
     $str = wm3Rss::renderHeadRss($w3,$languageID);

     // News rss items
     while($row = mysql_fetch_object($rs))
      {
       // Render news rss item
	   $title    = $row->title;
	   $link     = $base_link.$extra_link."&newsID=$row->newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
	   $news     = wm3Util::renderContent($w3,str_replace('[more]','',$row->news),$row->render_mode,true,$link);
	   $ts       = $row->news_ts;
       $author   = wm3User::getUserLogin($row->userID);
       $comments = $base_link.$extra_link."&newsID=$row->newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
	   $category = wm3News::getNewsCategoryName($w3,$row->categoryID);

	   $str .= wm3Rss::renderItemRss($w3,$title,$link,$news,$ts,$author,$comments,$category);
      }

	 // Rss foot
	 $str .= wm3Rss::renderFootRss($w3);

	 return $str;
	}

   public function renderRssPanelNews($w3)
    {
     // Render RSS feed panel in home page
     $columns = 2; $buttons = 0;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_RSS;
     $languageID = $w3->getHomeLanguage();

     // Create list header
     $str = wm3Section::makeHeaderList($w3,array(),$columns);

     // All RSS feed
     $link = $base_link;
     $str .= wm3Section::makeItemList($w3,0,array(100),array("<a href=\"$link&languageID=$languageID\">".wm3Util::renderImg('misc_rss_big.png')." ".$w3->getWord(1642)."</a>"),false,array(2));

     // RSS feed by news category
     $str .= wm3Section::makeItemList($w3,0,array(100),array("<br>".$w3->getWord(1613)),false,array(2));
     $str .= wm3News::renderRssCategoryListNews($w3,$languageID);

     // RSS feed by author
     $str .= wm3Section::makeItemList($w3,0,array(100),array("<br>".$w3->getWord(1614)),false,array(2));
     $str .= wm3News::renderRssAuthorListNews($w3,$languageID);

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public function renderRssCategoryListNews($w3,$languageID)
    {
     // Render RSS feed category list for home page panel
     $columns = 2; $buttons = 0;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_RSS;

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_news_categories
                        WHERE enabled = '".WM3_cENABLED."' AND languageID = '$languageID'
                        ORDER BY name";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,1633);

     // Create list items
     $p = 1; $str = "";
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
	   $link = $base_link."&categoryID=$row->categoryID&languageID=$languageID&action=".WM3_cACTION_SHOW_RSS_CATEGORY;
       $name = "<a href=\"$link\">".wm3Util::renderImg('misc_rss.png','',12,12)." $row->name</a>";
       array_push($_CONTENTS,"&nbsp;",$name); array_push($_WIDTHS,0,100);
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }

     return $str;
    }

   public function renderRssAuthorListNews($w3,$languageID)
    {
     // Render RSS feed author list for home page panel
     $columns = 2; $buttons = 0;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_RSS;

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_users.userID, ".WM3_cCONFIG_DB_PREFIX."_users.login
	             FROM ".WM3_cCONFIG_DB_PREFIX."_users,
	                  ".WM3_cCONFIG_DB_PREFIX."_news
                WHERE ".WM3_cCONFIG_DB_PREFIX."_users.enabled = '".WM3_cENABLED."'
				  AND ".WM3_cCONFIG_DB_PREFIX."_users.deleted = '".WM3_cDISABLED."'
				  AND ".WM3_cCONFIG_DB_PREFIX."_news.userID = ".WM3_cCONFIG_DB_PREFIX."_users.userID
				  AND ".WM3_cCONFIG_DB_PREFIX."_news.enabled = '".WM3_cENABLED."'
			    GROUP BY login
                ORDER BY login";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,1633);

     // Create list items
     $p = 1; $str = "";
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link."&userID=$row->userID&languageID=$languageID&action=".WM3_cACTION_SHOW_RSS_AUTHOR;
       $login = "<a href=\"$link\">".wm3Util::renderImg('misc_rss.png','',12,12)." $row->login</a>";
       array_push($_CONTENTS,"&nbsp;",$login); array_push($_WIDTHS,0,100);
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }

     return $str;
    }

   public static function getNewsTS($newsID)
    {
	 // Return news_ts for newsID
     $rs = wm3Sql::sqlQuery("SELECT news_ts FROM ".WM3_cCONFIG_DB_PREFIX."_news
                             WHERE newsID = '$newsID'");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->news_ts;
	}

   public static function hitNews($w3)
    {
     $newsID = $w3->getVariable('newsID','get');
	 if(!wm3Session::newsAllowed($newsID,WM3_cSESSION_HIT)) return;
	 else wm3Session::newsProtect($newsID,WM3_cSESSION_HIT);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news
                       SET    hits = hits + 1
                       WHERE  newsID = '$newsID'");
    }

  }

?>
