<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Newsletter
  {

   function __construct() { }

   public static function getNewsletterFieldsArray()
    {
     return array('newsletterID',
	              'newsletter_target','user_gender','groupID','ignore_disabled','newsletter_action',
				  'subject','newsletter_format','newsletter','newsletter_use_foot','languageID','save_newsletter','emails_sended','newsletter_target_users','ts','newsletter_foot','enabled');
    }

   public static function getNewsletterItemFieldsArray()
    {
     return array('newsletter_itemID','email','enabled','languageID','ts');
    }

   public static function executeHomeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_CONTACT:
        {
         wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
         $error = wm3Newsletter::checkContactError($w3);
         if(!$error) {
                      $allowed = wm3Newsletter::addToNewsletterContact($w3);
		              wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Newsletter::sendContact($w3,$allowed);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Newsletter::renderContact($w3,$error);
		             }
         break;
        }
       default:
        {
         return wm3Newsletter::renderContact($w3);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_NEWSLETTER_ITEM:
        {
         wm3Newsletter::disableNewsletterItem($w3->getVariable('newsletter_itemID','get'));
         return wm3Newsletter::getNewsletterItemList($w3,$w3->getVariable('newsletter_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_NEWSLETTER_ITEM:
        {
         wm3Newsletter::enableNewsletterItem($w3->getVariable('newsletter_itemID','get'));
         return wm3Newsletter::getNewsletterItemList($w3,$w3->getVariable('newsletter_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_NEWSLETTER_ITEM:
        {
         wm3Newsletter::deleteNewsletterItem($w3->getVariable('newsletter_itemID','get'));
         return wm3Newsletter::getNewsletterItemList($w3);
         break;
        }
       case WM3_cACTION_ADD_NEWSLETTER_ITEM:
        {
         return wm3Newsletter::addNewsletterItem($w3);
         break;
        }
       case WM3_cACTION_SAVE_NEWSLETTER_ITEM:
        {
         wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE");
         $error = wm3Newsletter::checkNewsletterItemError($w3);
         if(!$error)
          {
           $lastID = wm3Newsletter::saveNewsletterItem($w3);
           // $msg= message saved... //TODO
		   wm3Sql::sqlQuery("UNLOCK TABLES");
           return wm3Newsletter::getNewsletterItemList($w3,$lastID);
          }
         else
		  {
	       wm3Sql::sqlQuery("UNLOCK TABLES");
		   return wm3Newsletter::addNewsletterItem($w3,$error);
		  }
         break;
        }
       case WM3_cACTION_EDIT_NEWSLETTER_ITEM:
        {
         return wm3Newsletter::editNewsletterItem($w3);
         break;
        }
       case WM3_cACTION_UPDATE_NEWSLETTER_ITEM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE");
         $error = wm3Newsletter::checkNewsletterItemError($w3);
         if(!$error)
          {
           $lastID = wm3Newsletter::updateNewsletterItem($w3);
           // $msg= message udated... //TODO
		   wm3Sql::sqlQuery("UNLOCK TABLES");
           return wm3Newsletter::getNewsletterItemList($w3,$lastID);
          }
         else
		  {
		   wm3Sql::sqlQuery("UNLOCK TABLES");
		   return wm3Newsletter::editNewsletterItem($w3,$error);
	      }
         break;
        }
       case WM3_cACTION_DELETE_NEWSLETTER:
        {
         wm3Newsletter::deleteNewsletter($w3->getVariable('newsletterID','get'));
         return wm3Newsletter::getNewsletterList($w3);
         break;
        }
       case WM3_cACTION_WRITE_NEWSLETTER:
        {
         return wm3Newsletter::writeNewsletter($w3);
         break;
        }
       case WM3_cACTION_SEND_NEWSLETTER:
        {
         $error = wm3Newsletter::checkNewsletterError($w3);
         if(!$error)
          {
           return wm3Newsletter::sendNewsletter($w3);
           // $msg= message saved... //TODO
          }
         else return wm3Newsletter::writeNewsletter($w3,$error);
         break;
        }
       case WM3_cACTION_RESEND_NEWSLETTER:
        {
         return wm3Newsletter::resendNewsletter($w3);
         break;
        }
       case WM3_cACTION_SHOW_NEWSLETTER:
        {
         return wm3Newsletter::getNewsletterList($w3);
         break;
        }
       default:
        {
         return wm3Newsletter::getNewsletterItemList($w3);
        }
      }
    }

   public static function getNewsletterItemList($w3,$currentID = 0)
    {
     // Get newsletter emails list
     $max_page_items = 12; $columns = 5; $buttons = 3;
     $filter = $w3->getVariable('filter','both'); // Search field
	 $pg = $w3->getVariable('pg','both');
     if($filter) {
		          $search_link = "&filter=$filter";
     	          $query_filter = "WHERE email LIKE '%$filter%'";
     	         }
     else        { $search_link = $query_filter = ""; }
	 $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY email";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'newsletter_itemID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }	 
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_newsletter_search_form.inc");
     array_push($_CONTENTS,$w3->getWord(89));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     $str .= wm3Section::makeCaptionList($w3,array(60,40,0),array(221,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();       
       $link = $base_link.$id_link.$extra_link."&newsletter_itemID=$row->newsletter_itemID";
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" width=\"19\" height=\"13\" align=\"middle\">";
       array_push($_CONTENTS,"<a href=\"mailto:$row->email\">$row->email</a>",$lang_flag); array_push($_WIDTHS,60,40);
       // Buttons
       if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_NEWSLETTER_ITEM,"action_disable.png",$w3->getWord(180)));
       else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_NEWSLETTER_ITEM,"action_enable.png",$w3->getWord(181)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_NEWSLETTER_ITEM,"action_edit.png",$w3->getWord(178)));
       array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_NEWSLETTER_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(774)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->newsletter_itemID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkNewsletterError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterFieldsArray());
	 if(!$_FIELD['subject'])    return 1;
	 if(!$_FIELD['newsletter']) return 2;
     return 0;
    }

   public static function checkNewsletterItemError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterItemFieldsArray());
	 if(!wm3Util::isEmail($_FIELD['email']))              return 1;
	 if(wm3Newsletter::emailExists($w3,$_FIELD['email'])) return 2;
     return 0;
    }

   public static function checkSendToFriendError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(array('newsletter_itemID','friend_email','your_email','newsletter'));
	 if(!wm3Util::isEmail($_FIELD['friend_email'])) return 1;
	 if(!wm3Util::isEmail($_FIELD['your_email']))   return 2;
     return 0;
    }

   public static function addNewsletterItem($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Newsletter::getNewsletterItemFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterItemFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // Invalid email
        {
         $_STYLE['email']          = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(8);
         break;
        }
       case 2: // Email already exists
        {
         $_STYLE['email']          = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Email already exists"; //$w3->getWord(8);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled'] = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(351);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_NEWSLETTER_ITEM;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_newsletter_item_form.inc");
     return $content;
    }

   public static function editNewsletterItem($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                               WHERE newsletter_itemID = '".$w3->getVariable('newsletter_itemID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Newsletter::getNewsletterItemFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterItemFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Newsletter::getNewsletterItemFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // Invalid email 
        {
         $_STYLE['email']          = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 2: // Email already exists
        {
         $_STYLE['email']          = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Email already exists"; //$w3->getWord(8);
         break;
        }		
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit email ...."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_NEWSLETTER_ITEM;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_newsletter_item_form.inc");
     return $content;
    }

   public static function saveNewsletterItem($w3,$_FIELD = array())
    {
     if(count($_FIELD) == 0) $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterItemFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_newsletters_items',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updateNewsletterItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterItemFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                       SET email               = '".$_FIELD['email']."',
                           enabled             = '".$_FIELD['enabled']."',
                           languageID          = '".$_FIELD['languageID']."'
                       WHERE newsletter_itemID = '".$_FIELD['newsletter_itemID']."'");
     return $_FIELD['newsletter_itemID'];
    }

   public static function synchronizeNewsletterItem($w3)
    {
	 // Take email from varius tables and store it in newsletters (if not already stored)	 
	 $str = ""; $i = 0;
	 $_FIELD['newsletter_itemID'] = '';
	 $_FIELD['enabled']           = WM3_cENABLED;

	 // From users
     $rs = wm3Sql::sqlQuery("SELECT email,languageID FROM ".WM3_cCONFIG_DB_PREFIX."_users");
     while($row = mysql_fetch_object($rs))
      {
	   $_FIELD['email']      = $row->email;
	   $_FIELD['languageID'] = $row->languageID;
	   $_FIELD['ts']         = time();
       if(!wm3Newsletter::emailExists($w3,$row->email))
	    {
		 wm3Sql::saveAllTableFields('_newsletters_items',$_FIELD);
		 $i++;
		}
      }
	 $str .= "<i>$i email synchronized from users</i>"; $i = 0;

	 // From guestbook
     $rs = wm3Sql::sqlQuery("SELECT email,languageID FROM ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages");
     while($row = mysql_fetch_object($rs))
      {
	   $_FIELD['email']      = $row->email;
	   $_FIELD['languageID'] = $row->languageID;
	   $_FIELD['ts']         = time();
       if(!wm3Newsletter::emailExists($w3,$row->email))
	    {
		 wm3Sql::saveAllTableFields('_newsletters_items',$_FIELD);
		 $i++;
		}
      }
	 $str .= "<br><i>$i email synchronized from guestbook</i>";
     return $str;
    }

   public static function selectNewsletterItem($name,$messageID)
    {
     // Make message categories select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages");
     $str = "<select name=\"$name\">";
     while($row = mysql_fetch_object($rs))
      {
       if($row->messageID == $messageID) $str .= wm3Util::inputOption($row->arg_name,$row->arg_blockID,"selected");
       else                              $str .= wm3Util::inputOption($row->arg_name,$row->arg_blockID);
      }
     $str .= "</select>";
     return $str;
    }

   public static function selectNewsletterTarget($w3,$name,$target,$js = "")
    {
     // Make newsletter target select
     return wm3Util::selectArray($name,
                        array($w3->getWord(320),$w3->getWord(321)),
                        array(WM3_cNEWSLETTER_TARGET_MEMBERS,WM3_cNEWSLETTER_TARGET_USERS),
                        $target,
						$js);
    }

   public static function selectNewsletterGender($w3,$name,$type)
    {
     // Make newsletter gender select
     return wm3Util::selectArray($name,
                        array($w3->getWord(528),$w3->getWord(529),$w3->getWord(530),$w3->getWord(823)),
                        array(WM3_cUSER_ALL,WM3_cUSER_GENDER_MALE,WM3_cUSER_GENDER_FEMALE,WM3_cUSER_SPECIAL),
                        $type);
    }

   public static function selectNewsletterAction($w3,$name,$type)
    {
     // Make newsletter action select
     return wm3Util::selectArray($name,
                        array($w3->getWord(531),$w3->getWord(532)),
                        array(WM3_cNEWSLETTER_ACTION_SEND,WM3_cNEWSLETTER_ACTION_SIMULATE),
                        $type);
    }

   public static function selectNewsletterType($w3,$name,$newsletter_format,$js = "")
    {
     // Make newsletter type select
     return wm3Util::selectArray($name,
                        array($w3->getWord(550),$w3->getWord(549)),
                        array(WM3_cNEWSLETTER_FORMAT_TEXT,WM3_cNEWSLETTER_FORMAT_HTML),
                        $newsletter_format,
						$js);
    }

   public static function duplicateNewsletterItem($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages
                             WHERE messageID = '".$w3->getVariable('messageID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Newsletter::getNewsletterItemFieldsArray(),$row);
       $_FIELD['message'] = $w3->getWord(1417).$_FIELD['message'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['update_ts'] = $_FIELD['ts'] = time();
       wm3Sql::saveAllTableFields('_messages',$_FIELD,array('update_ts'));
       return wm3Sql::getLastInsertID();
      }
    }

   public static function disableNewsletterItem($newsletter_itemID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items SET enabled = '".WM3_cDISABLED."' WHERE newsletter_itemID = '$newsletter_itemID'");
    }

   public static function enableNewsletterItem($newsletter_itemID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items SET enabled = '".WM3_cENABLED."' WHERE newsletter_itemID = '$newsletter_itemID'");
    }
   
   public static function deleteNewsletterItem($newsletter_itemID)
    {
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WHERE newsletter_itemID = '$newsletter_itemID'");
    }

   public static function enableNewsletterItemEmail($email)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items SET enabled = '".WM3_cENABLED."' WHERE email = '$email'");
    }

   public static function getNewsletterList($w3,$currentID = 0)
    {
     // Get sended newsletter list
     $max_page_items = 12; $columns = 4; $buttons = 2;
     $filter = $w3->getVariable('filter','both'); // Search field
	 $pg = $w3->getVariable('pg','both');
     if($filter) {
		          $search_link = "&filter=$filter";
     	          $query_filter = "WHERE newsletter LIKE '%$filter%'";
     	         }
     else        { $search_link = $query_filter = ""; }
	 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_NEWSLETTER;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'newsletter_itemID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }	 
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_newsletter_search_form.inc");
     array_push($_CONTENTS,$w3->getWord(1134));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     $str .= wm3Section::makeCaptionList($w3,array(60,40,0),array(228,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();       
       $link = $base_link.$id_link.$extra_link."&newsletterID=$row->newsletterID";
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" width=\"19\" height=\"13\" align=\"middle\">";
	   $subject = "$row->subject<br>".wm3Util::renderDate($w3,$row->ts,$w3->getAdminLanguage());
	   if($row->newsletter_format == WM3_cNEWSLETTER_FORMAT_HTML) $format = $w3->getWord(549); else $format = $w3->getWord(550);
	   $info    = "$lang_flag ($row->emails_sended emails sended)<br>".$w3->getWord(324)." $format";
       array_push($_CONTENTS,$subject,$info); array_push($_WIDTHS,70,30);
       // Buttons
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_RESEND_NEWSLETTER,"action_reset.png",$w3->getWord(178)));
       array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_NEWSLETTER,"action_delete.png",$w3->getWord(179),$w3->getWord(774)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->newsletterID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_NEWSLETTER.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function writeNewsletter($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Newsletter::getNewsletterFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterFieldsArray());
     // Fields for paging default value
     $pg = $filter = "";
	 
     // Hide/Show correct field and error
     $_EXTRA_STYLE['newsletter_target_users'] = "style=\"display:none\"";
     if($_FIELD['newsletter_target']   == 2) $_EXTRA_STYLE['newsletter_target_users'] = "";
	 $_EXTRA_STYLE['newsletter_foot'] = "style=\"display:none\"";
	 if($_FIELD['newsletter_use_foot'] == WM3_cENABLED) $_EXTRA_STYLE['newsletter_foot'] = "";

     switch($error)
      {
       case 1: // No subject
        {
         $_STYLE['subject']        = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(367);
         break;
        }
       case 2: // No newsletter
        {
         $_STYLE['newsletter']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(860);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['categoryID']            = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['enabled']               = WM3_cENABLED;
		 $_FIELD['newsletter_use_foot']   = WM3_cENABLED;
		 $_FIELD['newsletter_format']     = 1;
		 $_EXTRA_STYLE['newsletter_foot'] = "";
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1673);
       	}
      }
	 $_FIELD['newsletter_foot'] = wm3Newsletter::makeNewsletterFoot($w3,$_FIELD['newsletter_format']);
	 $foot_text = wm3Newsletter::makeNewsletterFoot($w3,1,true);
	 $foot_html = wm3Newsletter::makeNewsletterFoot($w3,2,true);
     $next_action       = WM3_cACTION_SEND_NEWSLETTER;
     $next_action_label = $w3->getWord(294);
     require(WM3_cPATH_INCLUDE."admin_newsletter_form.inc");
     return $content;
    }

   public static function sendNewsletter($w3)
    {
     // Send the newsletter

	 // Prepare variables to create the emails list and send the newsletter
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterFieldsArray(),WM3_cQUOTE_DB);
	 if($_FIELD['newsletter_target'] == 1) // Newsletter
	  {
	   $columns = 4; $buttons = 3;
	   $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();

       // Newsletter synchronization
       wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items   WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_users               WRITE,
									 ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages WRITE");
	   $synchronize_message = "<br><br>".wm3Newsletter::synchronizeNewsletterItem($w3);
       wm3Sql::sqlQuery("UNLOCK TABLES");
	  }
	 if($_FIELD['newsletter_target'] == 2) // Users
	  {
	   $columns = 2; $buttons = 1;
	   $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_USERS;
	   $synchronize_message = "";
	  }
	 if($_FIELD['ignore_disabled']) $query_filter = "WHERE 1=1"; else $query_filter = "WHERE enabled = '".WM3_cENABLED."'";
     $id_link   = "";

     // Do the query and take the total items number
	 if($_FIELD['newsletter_target'] == 1) // Newsletter
	  {
       $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters_items $query_filter";
	  }
     if($_FIELD['newsletter_target'] == 2) // Users
	  {
	   if($_FIELD['user_gender'] == WM3_cUSER_GENDER_MALE)   $query_filter .= " AND gender = 'M'";
	   if($_FIELD['user_gender'] == WM3_cUSER_GENDER_FEMALE) $query_filter .= " AND gender = 'F'";
	   if($_FIELD['user_gender'] == WM3_cUSER_SPECIAL)       $query_filter .= " AND special = '".WM3_cENABLED."'";
	   if($_FIELD['groupID']) $query_filter .= " AND groupID = '".$_FIELD['groupID']."'";
       $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users $query_filter";
	  }
	 $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Save the newsletter
	 if($_FIELD['save_newsletter']) wm3Newsletter::saveNewsletter($w3,$total_items);

     // Create list header
     $_CONTENTS = array();
     array_push($_CONTENTS,$w3->getWord(371),$synchronize_message);
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,"");

     // Create list caption
     $str .= wm3Section::makeCaptionList($w3,array(100,0),array(221),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 1;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
	   
	   if($_FIELD['newsletter_action'] == 1) // Really send the newsletter
	     {
		  //$email_body = stripslashes($_FIELD['newsletter']);
		  $email_body = $_FIELD['newsletter'];
		  if($_FIELD['newsletter_use_foot']) $email_body .= $_FIELD['newsletter_foot'];
		  $sender = $w3->getPreferences('service_email');
          if($_FIELD['newsletter_format'] == WM3_cNEWSLETTER_FORMAT_TEXT) $sended = @mail($row->email,$_FIELD['subject'],$email_body,"From: $sender\nX-Mailer: PHP/".phpversion());
          if($_FIELD['newsletter_format'] == WM3_cNEWSLETTER_FORMAT_HTML) $sended = @mail($row->email,$_FIELD['subject'],$email_body,"From: $sender\nX-Mailer: PHP/".phpversion()."\nMIME-Version: 1.0\nContent-Type: text/html; charset=\"iso-8859-1\"\nContent-Transfer-Encoding: 7bit\n\n");
		 }
	   else $sended = true;

       if($sended) $sended = "<b>Sended OK!</b>";
	   else        $sended = "<b>Not sended, Error!</b>";
       if($_FIELD['newsletter_target'] == 1) // Newsletter
	    {
	     $link = $base_link.$id_link."&newsletter_itemID=$row->newsletter_itemID";
		 array_push($_CONTENTS,"$row->email $sended"); array_push($_WIDTHS,100);
	    }
	   if($_FIELD['newsletter_target'] == 2) // Users
	    {
		 $link = $base_link.$id_link."&userID=$row->userID";
         //$lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" width=\"19\" height=\"13\" align=\"middle\">";
		 array_push($_CONTENTS,"$row->email, $row->name $row->surname ($row->login) $sended"); array_push($_WIDTHS,100);
	    }

       // Buttons
	   if($_FIELD['newsletter_target'] == 1) // Newsletter
	    {
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_NEWSLETTER_ITEM,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_NEWSLETTER_ITEM,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_NEWSLETTER_ITEM,"action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_NEWSLETTER_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(774)));
		}
	   if($_FIELD['newsletter_target'] == 2) // Users
	    {
         //if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_USER,"action_disable.png",$w3->getWord(180)));
         //else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_USER,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_USER,"action_edit.png",$w3->getWord(178)));
		}
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }

     // Create list bottom
     $bottom_content = $w3->getWord(615)." $total_items ".$w3->getWord(616);
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function resendNewsletter($w3)
    {
     // Take variables value from db and set correct form style
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters
                             WHERE newsletterID = '".$w3->getVariable('newsletterID','get')."'");
     $row = mysql_fetch_object($rs);
	 if(!$row) return wm3Section::makeNotFoundItem($w3);
     $_FIELD = webmatic3::getRowValueArray(wm3Newsletter::getNewsletterFieldsArray(),$row);
     // Default value for fields not in $row object
     $_FIELD['save_newsletter']   = WM3_cDISABLED;
	 $_FIELD['newsletter_action'] = 1; // TODO fare costante
     $_STYLE = wm3Skin::getFormStyleArray(wm3Newsletter::getNewsletterFieldsArray());
     //??? $pg     = $w3->getVariable('pg','both');
     //??? $filter = $w3->getVariable('filter','both');

     // Hide/Show correct field and error
     $_EXTRA_STYLE['newsletter_target_users'] = "style=\"display:none\"";
     if($_FIELD['newsletter_target'] == 2) $_EXTRA_STYLE['newsletter_target_users'] = "";
	 $_EXTRA_STYLE['newsletter_foot'] = "style=\"display:none\"";
	 if($_FIELD['newsletter_use_foot'] == WM3_cENABLED) $_EXTRA_STYLE['newsletter_foot'] = "";

     $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
     $form_title = $w3->getWord(1673);

	 $_FIELD['newsletter_foot'] = wm3Newsletter::makeNewsletterFoot($w3,$_FIELD['newsletter_format']);
	 $foot_text = wm3Newsletter::makeNewsletterFoot($w3,1,true);
	 $foot_html = wm3Newsletter::makeNewsletterFoot($w3,2,true);
     $next_action       = WM3_cACTION_SEND_NEWSLETTER;
     $next_action_label = $w3->getWord(294);
     require(WM3_cPATH_INCLUDE."admin_newsletter_form.inc");
     return $content;
    }

   public static function saveNewsletter($w3,$emails_sended)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['emails_sended'] = $emails_sended;
	 $_FIELD['enabled']       = WM3_cENABLED;
     $_FIELD['ts']            = time();
     wm3Sql::saveAllTableFields('_newsletters',$_FIELD,array('newsletter_action','save_newsletter','newsletter_target_users','newsletter_foot'));
     //return wm3Sql::getLastInsertID();
    }

   public static function deleteNewsletter($newsletterID)
    {
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters WHERE newsletterID = '$newsletterID'");
    }

   public function makeNewsletterFoot($w3,$type,$quote = false)
    {//TODO costanti
	 if($type == 1)
	  {
	   $str = "\n\n---------------------\n\n"; // Plain text
	   $link = "SITO?...TODO";
      }
	 else
	  {
	   $str = "<br><br><hr><br>\n\n";
	   $link = "<a href=\"TODO\">SITO?...TODO</a>";
	  }
     $str .= $w3->getWord(186).$link;
	 if($quote)
	  {
	   $str = str_replace("\n" ,"\\n", $str);
	   $str = str_replace("'" ,"\'",   $str);
	   $str = str_replace("\"" ,"\&quot;",$str);
      }
	 return $str;
    }

   public static function renderNewsletter($w3)
    {
     // Render newsletter panel in home page
     $columns = 2; $buttons = 0;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_HOME;

     // Create list header
     $str = wm3Section::makeHeaderList($w3,array(),$columns);

     // Create newsletter panel     
     $link = $base_link;//."&surveyID=$row->surveyID";
     $label     = $w3->getWord(221);
     $textfield = wm3Util::inputText('email','',16);
     $button    = "<div align=\"center\"><input type=\"submit\" name=\"send\" value=\"".$w3->getWord(294)."\"></div>";

     $str .= "<form name=\"wm3_form\" method=\"post\" action=\"$link&action=".WM3_cACTION_NEWSLETTER_JOIN."\">";
     $str .= wm3Section::makeItemList($w3,0,array(0,100),array($label,$textfield),false);
     $str .= wm3Section::makeItemList($w3,1,array(100),array($button),false,array(2));
     $str .= "</form>";
	 if($w3->getPreferences('show_total_newsletter'))
	  {
       $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWSLETTER);
       if($allowed) {
	                 $total          = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items');
	                 $total_disabled = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items',"WHERE enabled='".WM3_cDISABLED."'");
                     $total_enabled  = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items',"WHERE enabled='".WM3_cENABLED."'");
					 $label = "<br>".$w3->getWord(320)." $total<br>($total_disabled disabled, $total_enabled enabled)";
			        }
       else         {
	                 $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items',"WHERE enabled='".WM3_cENABLED."'");
					 $label = "<br>".$w3->getWord(320)." $total";
		            }
	   $str .= wm3Section::makeItemList($w3,0,array(100),array($label),false,array(2));
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str; 
    }

   public static function joinNewsletter($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterItemFieldsArray());
     $error = wm3Newsletter::checkNewsletterItemError($w3);
     switch($error)
      {
       case 1: // Invalid email
        {
		 $w3->getPageObj()->setSubTitle($w3->getWord(1151));
         return $w3->getWord(443)." <b>\"".wm3Util::renderContent($w3,$_FIELD['email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"</b> ".$w3->getWord(444);
         break;
        }
       case 2: // Email already exists
        {
		 $w3->getPageObj()->setSubTitle("Email already exists");
		 wm3Newsletter::enableNewsletterItemEmail($_FIELD['email']); // Eneble the newsletter item if exists
		 return "<b>\"".$_FIELD['email']."\"</b> ".$w3->getWord(64);
         break;
        }
       default: // No error
        {
		 $_FIELD['enabled']    = WM3_cENABLED;
		 $_FIELD['languageID'] = $w3->getHomeLanguage();
		 $_FIELD['ts']         = time();
         wm3Newsletter::saveNewsletterItem($w3,$_FIELD);
		 $w3->getPageObj()->setSubTitle("Email added");
         return "Email <b>\"".$_FIELD['email']."\"</b> was added to our newsletter";
     	}
      }
    }

   public static function renderSendToFriend($w3)
    {
     // Render send to friend panel in home page
     $columns = 2; $buttons = 0;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_HOME;

     // Create list header
     $str = wm3Section::makeHeaderList($w3,array(),$columns);

     // Create send to friend panel     
     $link  = $base_link;//."&surveyID=$row->surveyID";
     $label_friend_email = $w3->getWord(1522);
     $friend_email       = wm3Util::inputText('friend_email','',16);
     $label_your_email   = $w3->getWord(1520);
     $your_email         = wm3Util::inputText('your_email','',16);
	 $label_newsletter   = "Join newsletter";//$w3->getWord(221);//TODO
	 $newsletter         = wm3Util::inputCheckbox('newsletter',true);
     $button    = "<div align=\"center\"><input type=\"submit\" name=\"send\" value=\"".$w3->getWord(595)."\"></div>";

     $str .= "<form name=\"wm3_form\" method=\"post\" action=\"$link&action=".WM3_cACTION_SEND_TO_FRIEND."\">";
	 $str .= wm3Section::makeItemList($w3,0,array(0,100),array($label_friend_email,$friend_email),false);
     $str .= wm3Section::makeItemList($w3,1,array(0,100),array($label_your_email,$your_email),false);
	 $str .= wm3Section::makeItemList($w3,0,array(0,100),array($label_newsletter,$newsletter),false);
     $str .= wm3Section::makeItemList($w3,1,array(100),array($button),false,array(2));
	 $str .= "<input type=\"hidden\" name=\"_ID\" value=\"".time()."\">";
     $str .= "</form>";
	 if($w3->getPreferences('show_total_signalations'))
	  {
       $label = "<br>".wm3Preferences::loadTotalSignalations()." ".$w3->getWord(1484);
	   $str .= wm3Section::makeItemList($w3,0,array(100),array($label),false,array(2));
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str; 
    }

   public static function addToNewsletterSendToFriend($w3)
    {
     if(wm3Session::actionAllowed($w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3->getVariable('_ID','post'));

       $_FIELD = webmatic3::getPostValueArray(array('newsletter_itemID','friend_email','your_email','newsletter'),WM3_cQUOTE_DB);

       // Subscribe email also to newsletter
       if($_FIELD['newsletter']) $enabled = WM3_cENABLED; else $enabled = WM3_cDISABLED;
	   wm3Newsletter::addToNewsletter($w3,$_FIELD['friend_email'],$enabled);
	   wm3Newsletter::addToNewsletter($w3,$_FIELD['your_email'],$enabled);
       return true;
      }
	 return false; // Protected action error
    }

   public static function sendSendToFriend($w3,$allowed,$use_post_subject = false,$use_post_message = false)
    {
	 $w3->getPageObj()->setRenderHeadFoot(false);
     if($allowed)
      {
       $_FIELD = webmatic3::getPostValueArray(array('newsletter_itemID','friend_email','your_email','subject','message','message_head','newsletter'),WM3_cQUOTE_DB);
	   // Send the email to a friend
	   $friend_email = $_FIELD['friend_email'];
	   $your_email   = $_FIELD['your_email'];
       $sender     = $w3->getPreferences('service_email');
       if($use_post_subject) $subject = $_FIELD['subject'];
	   else                  $subject = $w3->getPreferencesContents('signalation_email_subject');
	   $subject .= " (from $your_email)";
       if($use_post_message) $email_body = $_FIELD['message'];
	   else                  $email_body = $w3->getPreferencesContents('signalation_email_text');
	   $email_body = $_FIELD['message_head'].$email_body; // Add a message head to the message if message head is passed from post
       $to         = $friend_email;
       $sended     = @mail($to,$subject,$email_body,"From: $sender\nX-Mailer: PHP/".phpversion());

       if($sended) {
		            $w3->getPageObj()->setSubTitle("Email sended to your friend...TODO");
                    $home_content = "Thank you <b>\"$your_email\"</b>.<br>A segnalation email was sended to <b>\"$friend_email\"</b>,<br>thanks! TODO";
					wm3Preferences::incrementTotalSignalationsPreferences();
		           }
	   else        {
					$home_content = "Email send error <b>$to</b>";//TODO
		           }
	   return $home_content;
      }
     else
      {
       $home_content = "Error: contact email already sended"; // TODO ???      	
      }
     return $home_content;
    }

   public static function renderSendToFriendError($w3,$error)
    {
	 $_FIELD = webmatic3::getPostValueArray(array('newsletter_itemID','friend_email','your_email','newsletter'));
     switch($error)
      {
       case 1: // Invalid friend email
        {
         $form_title = $w3->getWord(8);
         return "message error, <b>\"".wm3Util::renderContent($w3,$_FIELD['friend_email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"</b> bad email...";
         break;
        }
       case 2: // Invalid your email
        {
         $form_title = $w3->getWord(8);
         return "message error, <b>\"".wm3Util::renderContent($w3,$_FIELD['your_email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"</b> bad email...";
         break;
        }
       default: {} // No error
      }
    }

   public static function checkContactError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(array('name','email','subject','message','newsletter'));
     if(!$_FIELD['name'])           return 1;
     if(!wm3Util::isEmail($_FIELD['email'])) return 2;
     if(!$_FIELD['subject'])        return 3;
     if(!$_FIELD['message'])        return 4;
     return 0;
    }

   public static function renderContact($w3,$error = 0)
    {
     // Take variables value and set correct form style for user registration page (home side)
     $_AUX   = array('name','email','subject','message','newsletter');
     $_STYLE = wm3Skin::getFormStyleArray($_AUX);
     $_FIELD = webmatic3::getPostValueArray($_AUX);
     switch($error)
      {
       case 1:
        {
         $_STYLE['name']           = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(118);
         break;
        }
       case 2:
        {
         $_STYLE['email']          = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(376)." \"".$_FIELD['email']."\"".$w3->getWord(444);
         break;
        }
       case 3:
        {
         $_STYLE['subject']        = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(132);
         break;
        }
       case 4:
        {
         $_STYLE['message']        = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(132);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['newsletter'] = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(-1)."Spedisci un'email";
       	}
      }
     $_FIELD['pageID']  = $w3->getVariable('pageID','both'); // Take pageID from both
     $next_action       = WM3_cACTION_CONTACT; 
     $next_action_label = $w3->getWord(294);
     require(WM3_cPATH_INCLUDE."home_contact_form.inc");
     return $home_content;
    }

   public static function addToNewsletterContact($w3)
    {
     if(wm3Session::actionAllowed($w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3->getVariable('_ID','post'));

       $_FIELD = webmatic3::getPostValueArray(array('newsletter_itemID','name','email','subject','message','newsletter'),WM3_cQUOTE_DB);

       // Subscribe email also to newsletter
       if($_FIELD['newsletter']) $enabled = WM3_cENABLED; else $enabled = WM3_cDISABLED;
	   $email = $_FIELD['email'];	   
	   wm3Newsletter::addToNewsletter($w3,$email,$enabled);
       return true;
      }
	 return false; // Protected action error
    }

   public static function sendContact($w3,$allowed,$home_link = true)
    {
	 $w3->getPageObj()->setRenderHeadFoot(false);
     if($allowed)
      {
       $_FIELD = webmatic3::getPostValueArray(array('name','email','subject','message_head','message','newsletter'),WM3_cQUOTE_DB);
       // Send the email to webmaster's email
	   $name       = $_FIELD['name'];
	   $sender     = $_FIELD['email'];
       $subject    = $_FIELD['subject'];
       $email_body = "Message from $name\n\n".$_FIELD['message_head'].$_FIELD['message']; // Add a message head to the message if message head is passed from post
       $to         = $w3->getPreferences('webmaster_email');
       $sended     = @mail($to,$subject,$email_body,"From: $sender\nX-Mailer: PHP/".phpversion());
	   if($sended)
	    {
         $home_content =  $w3->getWord(496)." $name ".$w3->getWord(1404)." <b>$to</b><br>".$w3->getWord(1745);
         if($home_link) $home_content .= "<br><br> <a href=\"".WM3_cCONFIG_HOME_FILE."\">".$w3->getWord(1746)."</a>";
	    }
	   else
	    {
		 $home_content = "Email send error <b>$to</b>";//TODO
		}
      }
     else
      {
       $home_content = "Error: contact email already sended"; // TODO ???      	
      }
     return $home_content;
    }

   public static function emailExists($w3,$email)
    {
	 // Check if an email its already in the database
	 if($w3->getAction() == WM3_cACTION_UPDATE_NEWSLETTER_ITEM)
	  {
	   $newsletter_itemID = $w3->getVariable('newsletter_itemID','both');
	   $rs = wm3Sql::sqlQuery("SELECT email FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                               WHERE newsletter_itemID = '$newsletter_itemID'");
       $row = mysql_fetch_object($rs);
  	   if($row) $old_email = $row->email; else $old_email = "";
	   if($old_email == $email) return false;
	  }
     $rs = wm3Sql::sqlQuery("SELECT email FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                             WHERE email = '$email'");
     if(mysql_num_rows($rs) == 0) return false;
	 return true;
	}

   public function addToNewsletter($w3,$email,$enabled)
    {
	 // Add $email to newsletter or update (using $enabled) an existing one
     if(!wm3Newsletter::emailExists($w3,$email))
	  {
	   $_FIELD = array('newsletter_itemID' => '',
	                   'email'             => $email,
					   'enabled'           => $enabled,
					   'languageID'        => $w3->getHomeLanguage(),
					   'ts'                => time());
       wm3Newsletter::saveNewsletterItem($w3,$_FIELD);
	  }
     else
	  {
       // If email exists will be enabled only if $enabled its true
       if($enabled) wm3Newsletter::enableNewsletterItemEmail($email);
	  }
	}

  }

?>
