<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Webmail
  {

   function __construct() { }

   public static function getWebmailServerFieldsArray()
    {
     return array('serverID','name','visibility','languageID','enabled',
                  'in_suffix','in_use_suffix','in_address','in_port','in_protocol',
                  'out_login','out_password','out_address','out_port','out_authentication_type','out_use_internal',
                  'ts');
    }

   public static function getWebmailEmailFieldsArray()
    {
     return array('from','to','cc','bcc','subject','message','file');
    }

   public static function executeHomeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_REPLY_WEBMAIL_SERVER_EMAIL:
        {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
         if($inbox) {
                     wm3Folder::deleteFolderAllFile(WM3_cPATH_TEMP,wm3Webmail::getWebmailLoggedEmail($w3));
                     return wm3Webmail::renderWebmailWriteEmail($w3,$inbox,0,true);
                    }
		 else       return wm3Webmail::renderWebmailLogin($w3,$inbox);
         break;
        }
       case WM3_cACTION_WRITE_WEBMAIL_SERVER_EMAIL:
        {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
         if($inbox) {
			         wm3Folder::deleteFolderAllFile(WM3_cPATH_TEMP,wm3Webmail::getWebmailLoggedEmail($w3));
			         return wm3Webmail::renderWebmailWriteEmail($w3,$inbox);
				    }
		 else       return wm3Webmail::renderWebmailLogin($w3,$inbox);
         break;
        }
       case WM3_cACTION_GET_ATTACH_WEBMAIL_SERVER_EMAIL:
	    {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
         if($inbox) { imap_close($inbox); return wm3Folder::downloadFolderFileMd5(WM3_cPATH_TEMP,$w3->getVariable('filename','get')); }
		 else       return wm3Webmail::renderWebmailLogin($w3,$inbox);
         break;
        }
       case WM3_cACTION_DELETE_ATTACH_WEBMAIL_SERVER_EMAIL:
	    {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
         if($inbox) {
			         wm3Folder::deleteFolderFileMd5(WM3_cPATH_TEMP,$w3->getVariable('filename','post'));
					 return wm3Webmail::renderWebmailWriteEmail($w3,$inbox);
				    }
		 else       return wm3Webmail::renderWebmailLogin($w3,$inbox);
         break;
		}
       case WM3_cACTION_DELETE_ATTACH_ALL_WEBMAIL_SERVER_EMAIL:
	    {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
         if($inbox) {
                     wm3Folder::deleteFolderAllFile(WM3_cPATH_TEMP,wm3Webmail::getWebmailLoggedEmail($w3));
                     return wm3Webmail::renderWebmailWriteEmail($w3,$inbox);
                    }
		 else       return wm3Webmail::renderWebmailLogin($w3,$inbox);
         break;
        }
       case WM3_cACTION_SEND_WEBMAIL_SERVER_EMAIL:
        {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
         if($inbox) {		 
                     $error = wm3Webmail::checkWebmailSendEmailError($w3);
                     if(!$error)
                      {
					   return wm3Webmail::renderWebmailSendEmail($w3,$inbox);
				      }
					 else return wm3Webmail::renderWebmailWriteEmail($w3,$inbox,$error);
				    }
		 else       {
			         return wm3Webmail::renderWebmailLogin($w3,$inbox);
				    }
         break;
        }
       case WM3_cACTION_UPLOAD_ATTACH_WEBMAIL_SERVER_EMAIL:
        {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
         if($inbox) {
                     $error = wm3Webmail::checkWebmailUploadAttachEmailError($w3);
			         return wm3Webmail::renderWebmailWriteEmail($w3,$inbox,$error);
				    }
		 else       {
                     return wm3Webmail::renderWebmailLogin($w3,$inbox);
                    }
         break;
        }
	   case WM3_cACTION_SAVE_ATTACH_WEBMAIL_SERVER_EMAIL:
	    {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
         if($inbox) return wm3Webmail::saveWebmailAttachment($w3,$inbox);
		 else       return wm3Webmail::renderWebmailLogin($w3,$inbox);
         break;
		}
	   case WM3_cACTION_READ_WEBMAIL_SERVER_EMAIL:
	    {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
         if($inbox) return wm3Webmail::renderWebmailReadEmail($w3,$inbox);
		 else       return wm3Webmail::renderWebmailLogin($w3,$inbox);
         break;
		}
       case WM3_cACTION_DELETE_WEBMAIL_SERVER_EMAIL:
        {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
         if($inbox) {
			         wm3Webmail::renderWebmailDeleteEmail($w3,$inbox);
		             return wm3Webmail::renderWebmailInbox($w3,$inbox);
				    }
		 else        return wm3Webmail::renderWebmailLogin($w3,$inbox);
         break;
        }
       case WM3_cACTION_DELETE_MULTI_WEBMAIL_SERVER_EMAIL:
        {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
         if($inbox) {
					 wm3Webmail::renderWebmailDeleteMultiEmail($w3,$inbox);
		             return wm3Webmail::renderWebmailInbox($w3,$inbox);
				    }
		 else        return wm3Webmail::renderWebmailLogin($w3,$inbox);
         break;
		}
       case WM3_cACTION_LOGIN_WEBMAIL_SERVER:
        {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
		 if($inbox) return wm3Webmail::renderWebmailInbox($w3,$inbox);
		 else       return wm3Webmail::renderWebmailLogin($w3,$inbox,true);
         break;
        }
       case WM3_cACTION_LOGOUT_WEBMAIL_SERVER:
        {
		 wm3Webmail::renderWebmailLogout($w3);
         break;
        }
       default:
        {
		 $inbox = wm3Webmail::connectWebmailServerMailBox($w3);
		 if($inbox) return wm3Webmail::renderWebmailInbox($w3,$inbox);
		 else       return wm3Webmail::renderWebmailLogin($w3,$inbox);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_WEBMAIL_SERVER:
        {
         wm3Webmail::disableWebmailServer($w3->getVariable('serverID','get'));
         return wm3Webmail::getWebmailServerList($w3,$w3->getVariable('serverID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_WEBMAIL_SERVER:
        {
         wm3Webmail::enableWebmailServer($w3->getVariable('serverID','get'));
         return wm3Webmail::getWebmailServerList($w3,$w3->getVariable('serverID','get'));
         break;
        }
       case WM3_cACTION_DELETE_WEBMAIL_SERVER:
        {
         wm3Webmail::deleteWebmailServer($w3->getVariable('serverID','get'));
         return wm3Webmail::getWebmailServerList($w3);
         break;
        }
       case WM3_cACTION_ADD_WEBMAIL_SERVER:
        {
         return wm3Webmail::addWebmailServer($w3);
         break;
        }
       case WM3_cACTION_SAVE_WEBMAIL_SERVER:
        {
         $error = wm3Webmail::checkWebmailServerError($w3);
         if(!$error)
          {
           $lastID = wm3Webmail::saveWebmailServer($w3);
           // $msg= page saved... //TODO
           return wm3Webmail::getWebmailServerList($w3,$lastID);
          }
         else return wm3Webmail::addWebmailServer($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_WEBMAIL_SERVER:
        {
         return wm3Webmail::editWebmailServer($w3);
         break;
        }
       case WM3_cACTION_UPDATE_WEBMAIL_SERVER:
        {
         $error = wm3Webmail::checkWebmailServerError($w3);
         if(!$error)
          {
           $lastID = wm3Webmail::updateWebmailServer($w3);
           // $msg= user udated... //TODO
           return wm3Webmail::getWebmailServerList($w3,$lastID);
          }
         else return wm3Webmail::editWebmailServer($w3,$error);
         break;
        }
       default:
        {
         return wm3Webmail::getWebmailServerList($w3);
        }
      }
    }

   public static function getWebmailServerList($w3,$currentID = 0,$admin = true)
    {
     // Get mail servers list

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE name LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     if($admin)
      {
       $width_message = 70;
	   $search_form_link = WM3_cCONFIG_ADMIN_FILE;
       $columns = 7; $buttons = 3;
      }
     else
      {
       $width_message = 100;
       if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
       $query_filter .= "enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'";
       if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY name DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'serverID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0 && $admin) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array(); $search_form = "";
     if($admin)
      {
       require(WM3_cPATH_INCLUDE."admin_webmail_search_form.inc");
       array_push($_CONTENTS,$w3->getWord(1468));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(20,30,30,20,0),array(189,1492,1493,1407),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&serverID=$row->serverID";

       if($allowed) $allowed_link = $base_allowed_link."&serverID=$row->serverID";

       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
	   if($row->in_protocol == WM3_cWEBMAIL_SERVER_PROTOCOL_POP3)     $protocol_label = "POP3";
	   if($row->in_protocol == WM3_cWEBMAIL_SERVER_PROTOCOL_POP3_SSL) $protocol_label = "POP3/SSL";
       array_push($_CONTENTS,$row->name);
       array_push($_CONTENTS,"$row->in_address:$row->in_port ($protocol_label)");
       array_push($_CONTENTS,"$row->out_address:$row->out_port");
       array_push($_CONTENTS,$lang_flag);
       // Buttons
       if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_WEBMAIL_SERVER,"action_disable.png",$w3->getWord(180)));
       else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_WEBMAIL_SERVER,"action_enable.png",$w3->getWord(181)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_WEBMAIL_SERVER,"action_edit.png",$w3->getWord(178)));
       array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_WEBMAIL_SERVER,"action_delete.png",$w3->getWord(179),$w3->getWord(1463)));
       array_push($_WIDTHS,20,30,30,20);
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->serverID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
	   if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkWebmailUploadAttachEmailError($w3)
    {
     // Check form invalid inputs and upload error
     $_FIELD = webmatic3::getPostValueArray(wm3Folder::getFolderFileFieldsArray());
     $_ARRAY = wm3Folder::getFolderFieldsArray($w3);

     $aux = time()."_".rand(1,99999); // Generate a random name
     // Upload and give the name to the file
     $_MIME = array(); // Allow to attach any mime type //wm3Folder::mimeTypeImage();
	 $filename = wm3Webmail::getWebmailLoggedEmail($w3)."_".$aux."_".str_replace('/','_',$_FILES['file']['type'])."_".$_FILES['file']['name'];
     $error = wm3Folder::uploadFile("file",WM3_cPATH_TEMP,$filename,true,$_MIME);
     return $error; 
    }

   public static function checkWebmailServerError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Webmail::getWebmailServerFieldsArray());
     if(!$_FIELD['name']) return 1;
     return 0;
    }

   public static function addWebmailServer($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Webmail::getWebmailServerFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Webmail::getWebmailServerFieldsArray());
     switch($error)
      {
       case 1: // Empty name 
        {
         $_STYLE['name']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(123);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled']          = WM3_cENABLED;
         $_FIELD['in_use_suffix']    = WM3_cENABLED;
         //$_FIELD['out_use_internal'] = WM3_cDISABLE;
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1459);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_WEBMAIL_SERVER; 
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_webmail_server_form.inc");
     return $content;
    }

   public static function editWebmailServer($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                               WHERE serverID = '".$w3->getVariable('serverID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Webmail::getWebmailServerFieldsArray(),$row);
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Webmail::getWebmailServerFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Webmail::getWebmailServerFieldsArray());

     switch($error)
      {
       case 1: // Empty name 
        {
         $_STYLE['name']          = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit webmail server..."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_WEBMAIL_SERVER;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_webmail_server_form.inc");
     return $content;
    }

   public static function saveWebmailServer($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Webmail::getWebmailServerFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_webmail_servers',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updateWebmailServer($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Webmail::getWebmailServerFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                       SET   name                    = '".$_FIELD['name']."',
                             in_suffix               = '".$_FIELD['in_suffix']."',
                             in_use_suffix           = '".$_FIELD['in_use_suffix']."',
                             in_address              = '".$_FIELD['in_address']."',
						     in_port                 = '".$_FIELD['in_port']."',
						     in_protocol             = '".$_FIELD['in_protocol']."',
                             out_login               = '".$_FIELD['out_login']."',
                             out_password            = '".$_FIELD['out_password']."',
						     out_address             = '".$_FIELD['out_address']."',
                             out_port                = '".$_FIELD['out_port']."',
						     out_authentication_type = '".$_FIELD['out_authentication_type']."',
						     out_use_internal        = '".$_FIELD['out_use_internal']."',
                             visibility              = '".$_FIELD['visibility']."',
                             enabled                 = '".$_FIELD['enabled']."',
                             languageID              = '".$_FIELD['languageID']."'
                       WHERE serverID                = '".$_FIELD['serverID']."'");
     return $_FIELD['serverID'];
    }

   public static function disableWebmailServer($serverID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers SET enabled = '".WM3_cDISABLED."' WHERE serverID = '$serverID'");
	}

   public static function enableWebmailServer($serverID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers SET enabled = '".WM3_cENABLED."'  WHERE serverID = '$serverID'");
    }

   public static function deleteWebmailServer($serverID)
    {
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_webmail_servers WHERE serverID = '$serverID'");
    }

   public static function selectWebmailServerVisibility($w3,$name,$visibility)
    {
     // Make webmail visibility select
     return wm3Util::selectArray($name,
                        array($w3->getWord(935),$w3->getWord(936),$w3->getWord(1334)),
                        array(WM3_cWEBMAIL_SERVER_VISIBILITY_ALL,WM3_cWEBMAIL_SERVER_VISIBILITY_USERS,WM3_cWEBMAIL_SERVER_VISIBILITY_GROUP),
                        $visibility);
    }

   public static function selectWebmailServerProtocol($w3,$name,$protocol)
    {
     // Make webmail authentication type select
     return wm3Util::selectArray($name,
                        array($w3->getWord(-1)."POP3 (110)",$w3->getWord(-1)."POP3/SSL (995)"),
                        array(WM3_cWEBMAIL_SERVER_PROTOCOL_POP3,WM3_cWEBMAIL_SERVER_PROTOCOL_POP3_SSL),
                        $protocol);
    }

   public static function selectWebmailServerAuthenticationType($w3,$name,$type)
    {
     // Make webmail authentication type select
     return wm3Util::selectArray($name,
                        array($w3->getWord(1497),$w3->getWord(1498),$w3->getWord(1499)),
                        array(WM3_cWEBMAIL_SERVER_AUTHENTICATION_TYPE_SERVER,WM3_cWEBMAIL_SERVER_AUTHENTICATION_TYPE_SPECIFIED,WM3_cWEBMAIL_SERVER_AUTHENTICATION_TYPE_NONE),
                        $type);
    }

   public static function selectWebmailServerSuffix($w3,$name,$serverID)
    {
     // Make webmail suffix select
	 $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_webmail_servers WHERE enabled = '".WM3_cENABLED."'");
	 $str = "<select name=\"$name\">";
     while($row = mysql_fetch_object($rs))
      {
       if($row->serverID == $serverID) $str .= wm3Util::inputOption($row->in_suffix,$row->serverID,"selected");
       else                            $str .= wm3Util::inputOption($row->in_suffix,$row->serverID);
	  }
     $str .= "</select>";
     return $str;
    }

   public static function connectWebmailServerMailBox($w3,$timeout = 3)
    {
     if(isset($_COOKIE['webmail_serverID']) && isset($_COOKIE['webmail_login']) && isset($_COOKIE['webmail_password']))
	  {
	   // Try to connect using cookies
       $serverID = $_COOKIE['webmail_serverID'];
	   $login    = $_COOKIE['webmail_login'];
	   $password = $_COOKIE['webmail_password'];
	   $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_webmail_servers WHERE serverID = '$serverID' AND enabled = '".WM3_cENABLED."'");
       if(!mysql_num_rows($rs)) return false;
       $row = mysql_fetch_object($rs);
       if($row->in_protocol == WM3_cWEBMAIL_SERVER_PROTOCOL_POP3)     $protocol = "pop3";
	   if($row->in_protocol == WM3_cWEBMAIL_SERVER_PROTOCOL_POP3_SSL) $protocol = "pop3/ssl";
	   if($row->in_use_suffix) $login .= $row->in_suffix;

       //echo "{".$row->in_address.":".$row->in_port."/".$protocol."}INBOX"." $login $password";
	   $ts = time();
	   while(!$inbox && time() - $ts < $timeout) // Try connection with $timeout seconds
        $inbox = @imap_open("{".$row->in_address.":".$row->in_port."/".$protocol."}INBOX",$login,$password,NIL,1); // This line need php >= 5.2
	   if(!$inbox) // Remove the bad cookie
		{
	     setcookie("webmail_serverID","",time()-3600);
	     setcookie("webmail_login",   "",time()-3600);
	     setcookie("webmail_password","",time()-3600);
		}
	  }
	 else
	  {
	   // Try to connect using form data
       $_FIELD = webmatic3::getPostValueArray(array('webmail_login','webmail_password','webmail_serverID'));
       $serverID = $w3->getVariable('webmail_serverID','both');
	   $login    = $_FIELD['webmail_login'];
	   $password = $_FIELD['webmail_password'];
	   $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_webmail_servers WHERE serverID = '$serverID' AND enabled = '".WM3_cENABLED."'");
       if(!mysql_num_rows($rs)) return false;
       $row = mysql_fetch_object($rs);
       if($row->in_protocol == WM3_cWEBMAIL_SERVER_PROTOCOL_POP3)     $protocol = "pop3";
	   if($row->in_protocol == WM3_cWEBMAIL_SERVER_PROTOCOL_POP3_SSL) $protocol = "pop3/ssl";
	   if($row->in_use_suffix) $login .= $row->in_suffix;

       //echo "{".$row->in_address.":".$row->in_port."/".$protocol."}INBOX"." $login $password"; 
	   $ts = time();
	   while(!$inbox && time() - $ts < $timeout) // Try connection with $timeout seconds
        $inbox = @imap_open("{".$row->in_address.":".$row->in_port."/".$protocol."}INBOX",$login,$password,NIL,1); // This line need php >= 5.2
	   if(!$inbox) $inbox = @imap_open("{".$row->in_address.":".$row->in_port."/".$protocol."}INBOX",$login,$password);
	   if($inbox) // Set right cookies
	    {
	     setcookie("webmail_serverID",$_FIELD['webmail_serverID']);
	     setcookie("webmail_login",   $_FIELD['webmail_login']);
	     setcookie("webmail_password",$_FIELD['webmail_password']);
	    }
	  }
 	 return $inbox;
    }

   public static function renderWebmailLogin($w3,$inbox,$login_error = false)
    {
     $_STYLE = wm3Skin::getFormStyleArray(array('webmail_login','webmail_password','webmail_serverID'));
     $_FIELD = webmatic3::getPostValueArray(array('webmail_login','webmail_password','webmail_serverID'));

     if(!$inbox) // Not logged in
      {
       $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
	   $form_title = "&nbsp;";
	   if($login_error)
	    {
		 $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
		 $form_title = $w3->getWord(289);
		}
	   $pageID = $w3->getVariable('pageID','both');
       require(WM3_cPATH_INCLUDE."home_webmail_server_login_form.inc");
	   return $home_content;
      }
    }

   public static function renderWebmailInbox($w3,$inbox)
    {//TODO
     // Get inbox email list

     // Prepare variables to create the list
     $max_page_items = 12;
     $pageID = $w3->getVariable('pageID','both');
     $page_link = "&pageID=$pageID";
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE name LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
     $query_filter .= "enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'";
     $search_form_link = WM3_cCONFIG_ADMIN_FILE;
	 $columns = 7; $buttons = 1;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = "";

     // Do the query and take the total items number
	 $total_items = imap_check($inbox)->Nmsgs;
     //if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;*/
	 /*if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'serverID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }*/
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_webmail_search_form.inc");
	 $login = wm3Webmail::getWebmailLoggedEmail($w3);
	 array_push($_CONTENTS,$w3->getWord(1528)." $login ".$w3->getWord(888)." $total_items ".$w3->getWord(1531));
	 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link,"misc_email.png","","",$w3->getWord(1530),0,16,16));
	 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link."&action=".WM3_cACTION_WRITE_WEBMAIL_SERVER_EMAIL,"action_newsletter.png","","",$w3->getWord(1532),0,16,16));
	 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link."&action=".WM3_cACTION_LOGOUT_WEBMAIL_SERVER,"action_logout.png","","",$w3->getWord(-1)."logout",0,16,16));
	 $inbox_form = "<form name=\"wm3_form\" method=\"post\" action=\"$base_link$id_link$extra_link$page_link\">";
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form.$inbox_form);

     // Create list caption
     $str .= wm3Section::makeCaptionList($w3,array(0,0,20,30,30,20,0),array(-1,-1,1535,1286,578,1534),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) { imap_close($inbox); return $str.wm3Section::makeEmptyItemsList($w3,$columns,593); }

     // Create list items
     $p = 0;
	 $_WIDTHS = array(0,0,25,35,30,10);
	 for($i = 1; $i <= $total_items; $i++)
      {
       $_CONTENTS = array();
	   $header = imap_header($inbox,$i);
	   $emailID = intval($header->Msgno);
	   if(wm3Webmail::haveWebmailAttach($inbox,$i)) $attach = wm3Util::renderImg('misc_attach.png','',11,16); else $attach = "";
       $link = $base_link.$id_link.$extra_link.$page_link."&emailID=$emailID";
       $from    = "<a href=\"$link&action=".WM3_cACTION_READ_WEBMAIL_SERVER_EMAIL."\">".$header->from[0]->mailbox."@".$header->from[0]->host."</a>";//$header->fromaddress
       $subject = "<a href=\"$link&action=".WM3_cACTION_READ_WEBMAIL_SERVER_EMAIL."\">".$header->subject."</a>";
	   $date    = "<a href=\"$link&action=".WM3_cACTION_READ_WEBMAIL_SERVER_EMAIL."\">".wm3Util::renderDate($w3,$header->udate,$w3->getHomeLanguage())."</a>";
	   array_push($_CONTENTS,wm3Util::inputCheckbox('chk_email'.$i,$emailID));
	   array_push($_CONTENTS,$attach);
       array_push($_CONTENTS,$from);
	   array_push($_CONTENTS,$subject);
	   array_push($_CONTENTS,$date);
	   array_push($_CONTENTS,wm3Folder::renderFileSize($w3,$header->Size));
       // Buttons
       array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_WEBMAIL_SERVER_EMAIL,"action_delete.png",$w3->getWord(179),$w3->getWord(774)));
       
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }
	 $_CONTENTS = array();
	 array_push($_CONTENTS,"<input type=\"button\" name=\"check_all\" value=\"".$w3->getWord(1308)."\" onClick=\"wm3_checkAll(this.form,'chk_email',1,$total_items);\"> <input type=\"button\" name=\"uncheck_all\" value=\"".$w3->getWord(1309)."\" onClick=\"wm3_checkAll(this.form,'chk_email',0,$total_items);\"> <input type=\"button\" name=\"invert_selection\" value=\"".$w3->getWord(1310)."\" onClick=\"wm3_invertSelection(this.form,'chk_email',$total_items);\"> ".wm3Util::selectArray('action',array($w3->getWord(1508),$w3->getWord(1509)),array(0,WM3_cACTION_DELETE_MULTI_WEBMAIL_SERVER_EMAIL),0)." <input type=\"submit\" name=\"send\" value=\"".$w3->getWord(829)."\"><input type=\"hidden\" name=\"total_items\" value=\"$total_items\"></form>");
	 $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false,array($columns));
	 imap_close($inbox);

     // Create list bottom
     $bottom_content = "";
     //if($total_items > $max_page_items)
      {
	   //$bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function renderWebmailDeleteEmail($w3,$inbox)
    {
     // Delete an email
	 $emailID = $w3->getVariable('emailID','both');
     imap_delete($inbox,$emailID);
	 imap_expunge($inbox);
    }

   public static function renderWebmailDeleteMultiEmail($w3,$inbox)
    {
     // Delete all selected email
	 $total_items = intval($w3->getVariable('total_items','both'));
	 for($i = 1; $i <= $total_items; $i++)
	  {
	   $emailID = $w3->getVariable('chk_email'.$i,'post');
	   if($emailID) imap_delete($inbox,$emailID);
      }
	 imap_expunge($inbox);
    }

   public static function renderWebmailReadEmail($w3,$inbox)
    {//TODO
     // Render a single email content

     // Prepare variables to create the list
	 $emailID = $w3->getVariable('emailID','both');
     $pageID  = $w3->getVariable('pageID','both');
     $page_link = "&pageID=$pageID";
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field

     $search_form_link = WM3_cCONFIG_ADMIN_FILE;
	 $columns = 2; $buttons = 0;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = "";

	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_webmail_search_form.inc");
	 array_push($_CONTENTS,wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link,"misc_email.png","","",$w3->getWord(1530),0,16,16));
	 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link."&action=".WM3_cACTION_WRITE_WEBMAIL_SERVER_EMAIL,"action_newsletter.png","","",$w3->getWord(1532),0,16,16));
	 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link."&action=".WM3_cACTION_LOGOUT_WEBMAIL_SERVER,"action_logout.png","","",$w3->getWord(-1)."logout",0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
	 $header = @imap_header($inbox,$emailID);
     if(!$header) {imap_close($inbox); return $str.wm3Section::makeEmptyItemsList($w3,$columns,593); }

     // Create list items
     $_CONTENTS = array(); $_WIDTHS = array(20,80);

     $link = $base_link.$id_link.$extra_link.$page_link;
	 $body_structure = imap_fetchstructure($inbox,$emailID);
	 $body = wm3Webmail::getWebmailBody($w3,$inbox,$emailID);
     $from    = $header->from[0]->mailbox."@".$header->from[0]->host;//$header->fromaddress;
	 $to      = $header->to[0]->mailbox."@".$header->to[0]->host;//$header->toaddress;
     $subject = $header->subject;
	 $date    = wm3Util::renderDate($w3,$header->udate,$w3->getHomeLanguage());

	 $_CONTENTS = array(); array_push($_CONTENTS,"<b>".$w3->getWord(1535)."</b>",$from);
	 $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);
	 $_CONTENTS = array(); array_push($_CONTENTS,"<b>".$w3->getWord(-1)."To"."</b>",$to);
	 $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,$_CONTENTS,false);
	 $_CONTENTS = array(); array_push($_CONTENTS,"<b>".$w3->getWord(578)."</b>",$date);
	 $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);
	 $_CONTENTS = array(); array_push($_CONTENTS,"<b>".$w3->getWord(1286)."</b>",$subject);
	 $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,$_CONTENTS,false);
     $_CONTENTS = array(); array_push($_CONTENTS,$body);
	 $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,array(2));
     $str .= wm3Webmail::renderWebmailAttachment($w3,$inbox,$emailID);
     $_CONTENTS = array();
	 array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_WEBMAIL_SERVER_EMAIL."&emailID=$emailID","action_delete_mini.png","",$w3->getWord(774),$w3->getWord(1510),0,16,16)." <b>|</b> ".
	                       wm3Util::actionButton("$link&action=".WM3_cACTION_REPLY_WEBMAIL_SERVER_EMAIL."&emailID=$emailID","action_email_reply.png","","",$w3->getWord(1511),0,16,16));	 
	 $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,$_CONTENTS,false,array(2));
	 imap_close($inbox);

     // Create list bottom
	 $bottom_content = "Prev - Next";//TODO
     //$bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkWebmailSendEmailError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Webmail::getWebmailEmailFieldsArray());
     if(!wm3Util::isEmail($_FIELD['to'])) return 1;
     return 0;
    }

   public static function renderWebmailWriteEmail($w3,$inbox,$error = 0,$reply = false)
    {
     // Render a form to write a new email
     $pageID  = $w3->getVariable('pageID','both');
     $page_link = "&pageID=$pageID";
     $filter = $w3->getVariable('filter','both'); // Search field
     $search_form_link = WM3_cCONFIG_ADMIN_FILE;
	 $columns = 1;

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_webmail_search_form.inc");
	 array_push($_CONTENTS,wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link,"misc_email.png","","",$w3->getWord(1530),0,16,16));
	 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link."&action=".WM3_cACTION_WRITE_WEBMAIL_SERVER_EMAIL,"action_newsletter.png","","",$w3->getWord(1532),0,16,16));
	 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link."&action=".WM3_cACTION_LOGOUT_WEBMAIL_SERVER,"action_logout.png","","",$w3->getWord(-1)."logout",0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Webmail::getWebmailEmailFieldsArray());
	 $_FIELD = webmatic3::getPostValueArray(wm3Webmail::getWebmailEmailFieldsArray());
     if($reply) // Take fields from reply email contents
	  {
       $emailID = $w3->getVariable('emailID','both');
       $header = @imap_header($inbox,$emailID);
       if(!$header) { imap_close($inbox); return $str.wm3Section::makeEmptyItemsList($w3,$columns,593); }

	   $body_structure = imap_fetchstructure($inbox,$emailID);	   
       $_FIELD['to'] = $header->from[0]->mailbox."@".$header->from[0]->host;//$header->fromaddress;
       $_FIELD['subject'] = "Re: ".$header->subject;
       $date = wm3Util::renderDate($w3,$header->udate,$w3->getHomeLanguage());
	   $_FIELD['message'] = "\n\n-------------------------\n".wm3Webmail::getWebmailBody($w3,$inbox,$emailID);
      }
	 $_FIELD['from']   = wm3Webmail::getWebmailLoggedEmail($w3);
	 $_FIELD['pageID'] = $pageID;
     switch($error)
      {
       case 1: // Invalid "to" email 
        {
         $_STYLE['to']             = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(123);
         break;
        }
       default:
        {
         // Default values for the form
         //$_FIELD['enabled']          = WM3_cENABLED;
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1532);
       	}
      }
     $next_action       = WM3_cACTION_SEND_WEBMAIL_SERVER_EMAIL; 
     $next_action_label = $w3->getWord(1538);
	 $attached_files = wm3Webmail::renderWebmailAttachmentToSend($w3);
     require(WM3_cPATH_INCLUDE."home_webmail_server_write_email_form.inc");
	 imap_close($inbox);
     return $str.$home_content;
    }

   public static function renderWebmailSendEmail($w3,$inbox)
    {
	 // Send email (with attachments)
     $pageID  = $w3->getVariable('pageID','both');
     $page_link = "&pageID=$pageID";
     $filter = $w3->getVariable('filter','both'); // Search field
     $search_form_link = WM3_cCONFIG_ADMIN_FILE;
	 $columns = 1;

     // Create list header
     $_CONTENTS = array(); $_WIDTHS = array(100);
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_webmail_search_form.inc");
	 array_push($_CONTENTS,wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link,"misc_email.png","","",$w3->getWord(1530),0,16,16));
	 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link."&action=".WM3_cACTION_WRITE_WEBMAIL_SERVER_EMAIL,"action_newsletter.png","","",$w3->getWord(1532),0,16,16));
	 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link."&action=".WM3_cACTION_LOGOUT_WEBMAIL_SERVER,"action_logout.png","","",$w3->getWord(-1)."logout",0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     if(wm3Session::actionAllowed($w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3->getVariable('_ID','post'));
       $_FIELD = webmatic3::getPostValueArray(wm3Webmail::getWebmailEmailFieldsArray());
	   $sender  = wm3Webmail::getWebmailLoggedEmail($w3);
	   $to      = $_FIELD['to'];
       $subject = $_FIELD['subject'];
       $message = $_FIELD['message'];

       // Get attachments
       $path = WM3_cPATH_TEMP; $fd = opendir($path); $n = 0;
       while(($file = readdir($fd)))
        {
	     $_FILE = explode("_",$file,6);
         if($file != "." && $file != ".." && $file != "index.html" && $_FILE[0] == wm3Webmail::getWebmailLoggedEmail($w3))
          {
           $_ATTACHES['path'][$n]     = $path.$file;
		   $_ATTACHES['filename'][$n] = $_FILE[5];
           $_ATTACHES['type'][$n]     = $_FILE[3]."/".$_FILE[4];
           $_ATTACHES['data'][$n]     = base64_encode(fread(fopen($_ATTACHES['path'][$n],"rb"),filesize($_ATTACHES['path'][$n])));
		   $n++;
          }
        }
       closedir($fd);

       // Send email
	   if($n == 0) // Without attachments
	    {
		 // TODO plain text/HTML e priorità da form
		 $email_body = $message;
         $sended = @mail($to,$subject,$email_body,"From: $sender\nX-Mailer: PHP/".phpversion());
         //$sended = @mail($to,$subject,$email_body,"From: $sender\nX-Mailer: PHP/".phpversion()."\nMIME-Version: 1.0\nContent-Type: text/html; charset=\"iso-8859-1\"\nContent-Transfer-Encoding: 7bit\n\n"); // HTML
	    }
	   else // With attachments
        {
		 // TODO plain text/HTML e priorità da form
   	     $boundary    = "wm3_".md5(uniqid("valarsoft.com"));
         $priorities  = array( '1 (Highest)', '2 (High)', '3 (Normal)', '4 (Low)', '5 (Lowest)' );
         $priority    = $priorities[2];
         $charset     = "ISO-8859-1";
         $ctencoding  = "7bit";
         $disposition = "attachment";
         $header  = "From: $sender\nX-Priority: $priority\n";//CC: $cc\n";
         $header .= "Mime-Version: 1.0\nX-Mailer: PHP/".phpversion()."\n";
         $header .= "Content-Type: multipart/mixed; boundary=$boundary\n";
         $email_body  = "This is a multi-part message in MIME format.\n--$boundary\n";
         $email_body .= "Content-Type: text/plain; charset=$charset;\n";
         $email_body .= "Content-Transfer-Encoding: $ctencoding\n\n".$message."\n\n";
		 $email_body .= "--$boundary\n";
         for($i = 0; $i < $n; $i++)
          {
           $filename = $_ATTACHES['filename'][$i];
           $filetype = $_ATTACHES['type'][$i];
		   $email_body .= "Content-Type: $filetype; name=\"$filename\"\n";
		   $email_body .= "Content-Disposition: $disposition; filename=\"$filename\"\n";
		   $email_body .= "Content-Transfer-Encoding: base64\n\n";
           $email_body .= $_ATTACHES['data'][$i]."\n";
		   $email_body .= "--$boundary";
           if($i == ($n-1)) $email_body .= "--\n"; else $email_body .= "\n";
          }
		 //echo "<pre>".$header."\n\n\n\n".$email_body."</pre>";
         $sended = @mail($to,$subject,$email_body,$header);//"From: $sender\nX-Mailer: PHP/".phpversion());
        }

       if($sended) {
   	                $w3->getPageObj()->setSubTitle("Email sended!");
                    $msg = "Email was sended to <b>\"$to\"</b>!";
		           }
	   else        {
                    $msg = "Email send error <b>$to</b>";//TODO
		           }
      }
     else
      {
       $msg = "Error: contact email already sended"; // TODO ???      	
      }
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,array($msg),false);

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     imap_close($inbox);
     return $str;
    }

   public static function renderWebmailAttachment($w3,$inbox,$emailID)
    {
     // Render attachments for an email

     if(!wm3Webmail::haveWebmailAttach($inbox,$emailID)) return;
     // Prepare variables to create the list
     $pageID  = $w3->getVariable('pageID','both');
     $page_link = "&pageID=$pageID";
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field

	 $columns = 2; $buttons = 0;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = "";

	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";

     // Create list header
	 $_WIDTHS = array(20,80);
     $_CONTENTS = array("<b>".$w3->getWord(1502)."</b>");
	 $str = wm3Section::makeItemList($w3,1,$_WIDTHS,$_CONTENTS,false,array(2));

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
	 $header = @imap_header($inbox,$emailID);
     if(!$header) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
	 $p = 0;
	 $body_structure = imap_fetchstructure($inbox,$emailID);
	 for($i = 0; $i < count($body_structure->parts); $i++)
	  {
       $_CONTENTS = array();

	   $link = $base_link.$id_link.$extra_link.$page_link."&emailID=$emailID";
	   if($body_structure->parts[$i]->ifdisposition) // Attachment found
        {
         $filename = "<a href=\"$link&attachID=$i&action=".WM3_cACTION_SAVE_ATTACH_WEBMAIL_SERVER_EMAIL."\">".$body_structure->parts[$i]->dparameters[0]->value."</a>";
         $type      = wm3Folder::mimeTypeEmail($body_structure->parts[$i]->type);
         $subtype   = strtolower($body_structure->parts[$i]->subtype);
         $mime_type = $type."/$subtype";
         array_push($_CONTENTS,$filename,$mime_type.", ".wm3Folder::renderFileSize($w3,$body_structure->parts[$i]->bytes));
         $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
         $p++;
	    }
	  }

     // Create list bottom

     return $str;
    }

   public static function saveWebmailAttachment($w3,$inbox)
    {
     // Save an attachments for an email

     $emailID  = $w3->getVariable('emailID','both');
     $attachID = $w3->getVariable('attachID','both');
     if(!wm3Webmail::haveWebmailAttach($inbox,$emailID)) { imap_close($inbox); return; }
     $body_structure = imap_fetchstructure($inbox,$emailID);
     $attach = imap_fetchbody($inbox,$emailID,$attachID+1);// +1 ???
     
     $filename  = $body_structure->parts[$attachID]->dparameters[0]->value;
	 $type      = wm3Folder::mimeTypeEmail($body_structure->parts[$attachID]->type);
	 $subtype   = strtolower($body_structure->parts[$attachID]->subtype);
     $encoding  = $body_structure->parts[$attachID]->encoding;
	 $mime_type = $type."/$subtype";
     header("Content-type: $mime_type"); 
     header("Content-Disposition: attachment; filename=$filename");
     switch($encoding)
      {
       case 0: { $attach = imap_8bit($attach);   break; } // 7bit (imap_utf7_encode() ???)
	   case 1: { $attach = imap_8bit($attach);   break; }
       case 2: { $attach = imap_binary($attach); break; } 
       case 3: { $attach = imap_base64($attach); break; } 
       case 4: { $attach = quoted_printable_decode($attach); break;}
       //case 5: { $attach=$attach; break; }
	   default: { $attach = $attach; }
      }
     echo $attach; 
     imap_close($inbox);
	 die;
    }

   public static function renderWebmailLogout($w3)
    {
	 // Logout from webmail server
     $pageID  = $w3->getVariable('pageID','both');
     $page_link = "&pageID=$pageID";
	 setcookie("webmail_serverID","",time()-3600);
	 setcookie("webmail_login",   "",time()-3600);
	 setcookie("webmail_password","",time()-3600);
     header("Location: ".WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES.$page_link); // Redirect to webmail page
     die;
    }

   public static function getWebmailLoggedEmail($w3)
    {
     // Return logged email from serverID
	 if(isset($_COOKIE['webmail_login'])) $login = $_COOKIE['webmail_login'];
	 else                                 $login = $w3->getVariable('webmail_login','post');
	 if(isset($_COOKIE['webmail_serverID'])) $serverID = $_COOKIE['webmail_serverID'];
	 else                                    $serverID = $w3->getVariable('webmail_serverID','post');

     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                             WHERE serverID = '$serverID'");
     if(mysql_num_rows($rs) != 1) return "";
     $row = mysql_fetch_object($rs);
     if($row->in_use_suffix) return $login.$row->in_suffix;
	 else                    return $login;
    }

   public static function haveWebmailAttach($inbox,$emailID)
    {
	 // Return true if an email have at least an attachment else return false
	 $body_structure = imap_fetchstructure($inbox,$emailID);

	 if($body_structure->type == 1) // Multipart content
	  for($i = 0; $i < count($body_structure->parts); $i++)
	   if($body_structure->parts[$i]->ifdisposition) return true; // Attachment found
	 return false;
	}

   public static function getWebmailBody($w3,$inbox,$emailID)
    {
	 // Return the body of message
	 // TODO contollare
	 $body_structure = imap_fetchstructure($inbox,$emailID);
//echo "<pre>"; print_r($body_structure); echo "</pre>";
	 if($body_structure->type == 1) // Multipart
	  {
       if($body_structure->subtype == "ALTERNATIVE")
	    $body = wm3Util::renderContent($w3,imap_fetchbody($inbox,$emailID,2),WM3_cRENDER_MODE_HTML);
       if($body_structure->subtype == "MIXED")
	    {
	     if($body_structure->parts[0]->type == 1) // Multipart
		  {
           if($body_structure->parts[0]->subtype == "ALTERNATIVE")
	        $body = wm3Util::renderContent($w3,imap_fetchbody($inbox,$emailID,1.2),WM3_cRENDER_MODE_HTML);
		  }
		 else
		  {  
           if($body_structure->parts[0]->subtype == "HTML")
            $body = wm3Util::renderContent($w3,imap_fetchbody($inbox,$emailID,1),WM3_cRENDER_MODE_HTML);
	       if($body_structure->parts[0]->subtype == "PLAIN")
	        $body = wm3Util::renderContent($w3,imap_fetchbody($inbox,$emailID,1),WM3_cRENDER_MODE_PLAIN_TEXT);
	      }
		}
	  }
	 else
	  {
       if($body_structure->subtype == "HTML")
        $body = wm3Util::renderContent($w3,imap_fetchbody($inbox,$emailID,1),WM3_cRENDER_MODE_HTML);
	   if($body_structure->subtype == "PLAIN")
	    $body = wm3Util::renderContent($w3,imap_fetchbody($inbox,$emailID,1),WM3_cRENDER_MODE_PLAIN_TEXT);
	  }
	 return $body;
	}

   public static function renderWebmailAttachmentToSend($w3)
    {
     // Render attachments to send

     // Prepare variables to create the list
     $pageID = $w3->getVariable('pageID','both');
     $page_link = "&pageID=$pageID";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $columns = 3; $buttons = 1;
	 $path = WM3_cPATH_TEMP;

     // Do the query and take the total items number
     $total_items = wm3Folder::getFolderItems($path); //TODO correggere bug qui (controllare che i file inizino con l'email loggata)...

     // Create list header
	 $_WIDTHS = array(30,70);
	 if($total_items) $delete_all = " <input type=\"submit\" name=\"send\" value=\"".$w3->getWord(1505)."\" onClick=\"document.wm3_form_webmail.action.value=".WM3_cACTION_DELETE_ATTACH_ALL_WEBMAIL_SERVER_EMAIL.";\">";
     $_CONTENTS = array("<b>".$w3->getWord(1502)."</b>$delete_all");
	 $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,'',false);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593,true);

     // Create list items
     $fd = opendir($path); $p = 0;
     while(($file = readdir($fd)))
      {
       $_CONTENTS = array();
	   $_FILE = explode("_",$file,6);
       if($file != "." && $file != ".." && $file != "index.html" && $_FILE[0] == wm3Webmail::getWebmailLoggedEmail($w3))
        {
         $link = $base_link.$page_link."&filename=".md5($file);
         $file_size = filesize($path.$file);
         array_push($_CONTENTS,"<a href=\"$link&action=".WM3_cACTION_GET_ATTACH_WEBMAIL_SERVER_EMAIL."\">$_FILE[5]</a>");		 
         array_push($_CONTENTS,"(".$_FILE[3]."/".$_FILE[4].") $file_size bytes"); 
         // Buttons
		 array_push($_CONTENTS,"<input type=\"submit\" name=\"send\" value=\"".$w3->getWord(179)."\" onClick=\"document.wm3_form_webmail.filename.value='".md5($file)."'; document.wm3_form_webmail.action.value='".WM3_cACTION_DELETE_ATTACH_WEBMAIL_SERVER_EMAIL."'; return wm3_accept('".$w3->getWord(699)."');\">");
         $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
         $p++;
        }
      }
     closedir($fd);

     // Create list bottom

     return $str;
    }

  }

?>
